import { StorageService } from '../storage/storage.service';
import { DatabaseService } from '../storage/database.service';
import { WebSocketsService } from '../websockets/websockets.service';
import { Observable } from "rxjs";
import { EventsManagerService } from "../common/events-manager.service";
export declare class AuthService {
    private storage;
    private database;
    private eventsManagerService;
    clientSecret: string;
    clientId: string;
    webSocketsService: WebSocketsService;
    private refresTokenTimer;
    private _tokenWillExpire;
    readonly tokenWillExpire: Observable<any>;
    constructor(storage: StorageService, database: DatabaseService, eventsManagerService: EventsManagerService);
    setWebSocketsService(webSocketsService: WebSocketsService): void;
    logout(): void;
    isLoggedIn(): boolean;
    getAccessToken(): Object;
    getRefreshToken(): Object;
    setClientId(clientId: string): void;
    setClientSecret(clientSecret: string): void;
    getClientId(): string;
    getClientSecret(): string;
    private startRefreshTokenTimeout(ttl);
    getNewAccessTokenFromRefreshToken(): void;
    setAccessToken(accessToken: string, ttl: number): boolean;
    setRefreshToken(refreshToken: string): boolean;
    getUser(): Object;
    setUser(user: any): boolean;
    setAccount(account: any): boolean;
    getAccount(): Object;
}
