import { Subject } from 'rxjs';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/catch';
import 'rxjs/add/operator/map';
import 'rxjs/add/observable/throw';
import { AuthService } from "../auth/auth.service";
import { IRequestOptions } from "./request-options.interface";
import { EventsManagerService } from "../common/events-manager.service";
import { HttpInterceptor } from "../common/http-interceptor.service";
export declare class APIClientService {
    protected defaultPath: string;
    protected http: HttpInterceptor;
    authService: AuthService;
    eventsManagerService: EventsManagerService;
    readonly apiURL: string;
    _onServerError: Subject<any>;
    readonly onServerError: Observable<any>;
    constructor(defaultPath: string, http: HttpInterceptor, authService: AuthService, eventsManagerService: EventsManagerService);
    get(path?: string, data?: any, options?: IRequestOptions): Observable<any>;
    private addUrlParams(data, resourcePath);
    remove(path?: string, data?: any, options?: IRequestOptions): Observable<any>;
    post(path?: string, data?: any, options?: any): Observable<any>;
    put(path?: string, data?: any, options?: any): Observable<any>;
    private extractData(res);
    private handleError(error);
}
