import { Subject } from "rxjs";
export var BACKEND_DATA_LIMIT = 25;
export var AppConfiguration = (function () {
    function AppConfiguration() {
    }
    Object.defineProperty(AppConfiguration, "onConfigChange", {
        get: function () {
            return AppConfiguration._onConfigChange.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    AppConfiguration.restoreInitialConfiguration = function () {
        AppConfiguration._currentConfig = Object.assign({}, AppConfiguration._initialConfig);
        AppConfiguration.setAPIURL(AppConfiguration._currentConfig.apiURL);
    };
    Object.defineProperty(AppConfiguration, "initialConfig", {
        set: function (config) {
            if (!config.currentAPIVersion) {
                config.currentAPIVersion = 'v2';
            }
            AppConfiguration._initialConfig = Object.assign({}, config);
            AppConfiguration._currentConfig = Object.assign({}, config);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfiguration, "currentConfig", {
        get: function () {
            return AppConfiguration._currentConfig;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfiguration, "currentAPIURL", {
        get: function () {
            return AppConfiguration._currentConfig.apiURL;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppConfiguration, "useLocalConnection", {
        get: function () {
            return AppConfiguration._currentConfig.useLocalConnection;
        },
        set: function (value) {
            AppConfiguration._currentConfig.useLocalConnection = value;
        },
        enumerable: true,
        configurable: true
    });
    AppConfiguration.setAPIURL = function (apiURL) {
        console.log('API URL set to: ' + apiURL);
        AppConfiguration._currentConfig.apiURL = apiURL;
        AppConfiguration._currentConfig.apiURLSet = true;
        AppConfiguration._onConfigChange.next({ config: AppConfiguration._currentConfig });
    };
    AppConfiguration.setCurrentGateway = function (gateway) {
        AppConfiguration._currentConfig.currentGateway = gateway;
    };
    AppConfiguration._onConfigChange = new Subject();
    return AppConfiguration;
}());
//# sourceMappingURL=app-configuration.js.map