import { APIClientService } from './api-client.service';
import { AuthService } from "../auth/auth.service";
import { EventsManagerService } from "../common/events-manager.service";
import { Observable } from "rxjs";
import { IRequestOptions } from "./request-options.interface";
import { HttpInterceptor } from "../common/http-interceptor.service";
export declare abstract class CRUDService extends APIClientService {
    readonly ResourceName: string;
    protected resource: string;
    constructor(resource: string, http: HttpInterceptor, authService: AuthService, eventsService: EventsManagerService);
    abstract createModel(data: any): any;
    save(data: any, options?: IRequestOptions): Observable<any>;
    getById(resourceId: string, options?: IRequestOptions): Observable<any>;
    removeById(resourceId: string, options?: IRequestOptions): Observable<any>;
    list(query?: any, options?: IRequestOptions): Observable<any>;
}
