var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { APIClientService } from './api-client.service';
import { AuthService } from "../auth/auth.service";
import { EventsManagerService } from "../common/events-manager.service";
import { Observable } from "rxjs";
import { HttpInterceptor } from "../common/http-interceptor.service";
export var CRUDService = (function (_super) {
    __extends(CRUDService, _super);
    function CRUDService(resource, http, authService, eventsService) {
        _super.call(this, resource, http, authService, eventsService);
        this.resource = resource;
    }
    Object.defineProperty(CRUDService.prototype, "ResourceName", {
        get: function () {
            return this.resource;
        },
        enumerable: true,
        configurable: true
    });
    CRUDService.prototype.save = function (data, options) {
        var _this = this;
        if (data && typeof data.toStoreObject === 'function') {
            data = data.toStoreObject();
        }
        if (data && data.hasOwnProperty('_id')) {
            return this.put(data._id, data, options).map(function (apiResponse) {
                if (apiResponse && apiResponse.data) {
                    apiResponse.data = _this.createModel(apiResponse.data);
                }
                return apiResponse;
            });
        }
        else {
            return this.post(null, data, options).map(function (apiResponse) {
                if (apiResponse && apiResponse.data) {
                    apiResponse.data = _this.createModel(apiResponse.data);
                }
                return apiResponse;
            });
        }
    };
    CRUDService.prototype.getById = function (resourceId, options) {
        var _this = this;
        var data = {};
        if (!resourceId || resourceId.length == 0) {
            return Observable.throw(new Error('Invalid resourceId to getById'));
        }
        if (options && options.fields) {
            data.fields = options.fields;
        }
        return _super.prototype.get.call(this, resourceId, data, options).map(function (apiResponse) {
            if (apiResponse && apiResponse.data) {
                apiResponse.data = _this.createModel(apiResponse.data);
            }
            return apiResponse;
        });
    };
    CRUDService.prototype.removeById = function (resourceId, options) {
        return _super.prototype.remove.call(this, resourceId, null, options);
    };
    CRUDService.prototype.list = function (query, options) {
        var _this = this;
        var data = {};
        if (options) {
            if (options.limit) {
                data.limit = options.limit;
            }
            if (options.page) {
                data.page = options.page;
            }
            if (options.fields && options.fields) {
                data.fields = options.fields.join(',');
            }
            if (options.sort && options.sort) {
                data.sort = options.sort.join(',');
            }
        }
        if (query) {
            data.q = JSON.stringify(query);
        }
        return this.get(null, data, options).map(function (apiResponse) {
            if (apiResponse && apiResponse.data && Array.isArray(apiResponse.data)) {
                for (var i = 0; i < apiResponse.data.length; i++) {
                    apiResponse.data[i] = _this.createModel(apiResponse.data[i]);
                }
            }
            return apiResponse;
        });
    };
    CRUDService = __decorate([
        Injectable(), 
        __metadata('design:paramtypes', [String, HttpInterceptor, AuthService, EventsManagerService])
    ], CRUDService);
    return CRUDService;
}(APIClientService));
//# sourceMappingURL=crud.service.js.map