var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
export var DataQueryService = (function () {
    function DataQueryService() {
    }
    DataQueryService.prototype.filterAndSliceData = function (data, query, options) {
        return this.sliceData(this.filterData(data, query), options);
    };
    DataQueryService.prototype.filterData = function (data, query) {
        var _this = this;
        if (!query || Object.keys(query).length === 0)
            return data;
        return data.filter(function (item) {
            return Object.keys(query).every(function (key) {
                return _this.findInKey(key.indexOf('.') > 0 ? key.split('.') : [key], item, query[key]);
            });
        });
    };
    DataQueryService.prototype.sliceData = function (data, options) {
        if (!options || !options.limit)
            return data;
        var _a = options.page, page = _a === void 0 ? 1 : _a, limit = options.limit;
        var startIdx = (page - 1) * limit;
        var endIdx = page * limit;
        return data.filter(function (item, idx) { return idx >= startIdx && idx < endIdx; });
    };
    DataQueryService.prototype.findInKey = function (keys, element, val) {
        var _this = this;
        if (keys.length === 1) {
            if (val.hasOwnProperty('$regex')) {
                return this.findRegex(keys[0], element, val);
            }
            else if (val.hasOwnProperty('$nin')) {
                return !this.findIn(keys[0], element, val);
            }
            else if (val.hasOwnProperty('$in')) {
                return this.findIn(keys[0], element, val);
            }
            else if (val.hasOwnProperty('$exists')) {
                return this.findExists(keys[0], element, val);
            }
            else {
                return this.findEquals(keys[0], element, val);
            }
        }
        var currentKey = keys.shift();
        if (!element.hasOwnProperty(currentKey))
            return false;
        if (Array.isArray(element[currentKey])) {
            return element[currentKey].some(function (elItem) {
                return _this.findInKey(keys, elItem, val);
            });
        }
        else {
            return this.findInKey(keys, element[currentKey], val);
        }
    };
    DataQueryService.prototype.findIn = function (key, element, val) {
        var values = val.$nin || val.$in;
        if (values != null) {
            if (Array.isArray((element[key]))) {
                return element[key].some(function (elItem) {
                    return values.some(function (valItem) { return (valItem.$oid || valItem) === (elItem.$oid || elItem); });
                });
            }
            else {
                return values.some(function (valItem) { return valItem && (valItem.$oid || valItem) === element[key]; });
            }
        }
        else {
            return false;
        }
    };
    DataQueryService.prototype.findRegex = function (key, element, val) {
        var values = val.$regex;
        var options = val.$options || '';
        if (values != null) {
            return (new RegExp(values, options)).test(element[key]);
        }
        else {
            return false;
        }
    };
    DataQueryService.prototype.findExists = function (key, element, val) {
        return val.$exists ? element.hasOwnProperty(key) : !element.hasOwnProperty(key);
    };
    DataQueryService.prototype.findEquals = function (key, element, val) {
        if (Array.isArray(element)) {
            return element.some(function (elItem) {
                return elItem.hasOwnProperty(key) && elItem[key] === (val.$oid || val);
            });
        }
        else {
            return element.hasOwnProperty(key) && element[key] === (val.$oid || val);
        }
    };
    DataQueryService = __decorate([
        Injectable(), 
        __metadata('design:paramtypes', [])
    ], DataQueryService);
    return DataQueryService;
}());
//# sourceMappingURL=data-query.service.js.map