import { Observable, Subject } from "rxjs";
import { APIClientService } from "../common/api-client.service";
import { AuthService } from "../auth/auth.service";
import { EventsManagerService } from "../common/events-manager.service";
import { DatabaseService } from "../storage/database.service";
import { HttpInterceptor } from "../common/http-interceptor.service";
export declare class DeviceReferenceService extends APIClientService {
    databaseService: DatabaseService;
    eventsService: EventsManagerService;
    protected _data: any;
    protected _loaded: boolean;
    protected _onLoaded: Subject<any>;
    readonly version: string;
    data: any;
    readonly onLoaded: Observable<any>;
    readonly isLoaded: boolean;
    constructor(http: HttpInterceptor, authService: AuthService, databaseService: DatabaseService, eventsService: EventsManagerService);
    loadFile(): void;
    private loadLocalVersion();
    private storeLocalVersion(remoteData);
    resolveGroups(data: any): any;
    injectTemplates(data: any): any;
    private isPositiveInteger(x);
    private validateParts(parts);
    versionCompare(v1: string, v2: string): number;
}
