var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { Subject } from 'rxjs';
export var EventsManagerService = (function () {
    function EventsManagerService() {
        this._onServerConnectivityError = new Subject();
        this._onTokenRefreshStart = new Subject();
        this._onTokenRefreshed = new Subject();
        this._onTokenRefreshError = new Subject();
        this._onUserSignIn = new Subject();
        this._onUserSignOut = new Subject();
        this._onConnectionSetup = new Subject();
        this._onConnectivityRecovered = new Subject();
    }
    Object.defineProperty(EventsManagerService.prototype, "onServerConnectivityError", {
        get: function () {
            return this._onServerConnectivityError.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EventsManagerService.prototype, "onConnectionSetup", {
        get: function () {
            return this._onConnectionSetup.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EventsManagerService.prototype, "onConnectivityRecovered", {
        get: function () {
            return this._onConnectivityRecovered.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EventsManagerService.prototype, "onUserSignIn", {
        get: function () {
            return this._onUserSignIn.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EventsManagerService.prototype, "onUserSignOut", {
        get: function () {
            return this._onUserSignOut.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EventsManagerService.prototype, "onTokenRefreshStart", {
        get: function () {
            return this._onTokenRefreshStart.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EventsManagerService.prototype, "onTokenRefreshed", {
        get: function () {
            return this._onTokenRefreshed.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(EventsManagerService.prototype, "onTokenRefreshError", {
        get: function () {
            return this._onTokenRefreshError.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    EventsManagerService.prototype.trigger = function (event, data) {
        if (this[event] && this[event] instanceof Subject) {
            this[event].next(data || {});
        }
    };
    EventsManagerService.ON_SERVER_CONNECTIVITY_ERROR = '_onServerConnectivityError';
    EventsManagerService.ON_TOKEN_REFRESH_START = '_onTokenRefreshStart';
    EventsManagerService.ON_TOKEN_REFRESHED = '_onTokenRefreshed';
    EventsManagerService.ON_TOKEN_REFRESH_ERROR = '_onTokenRefreshError';
    EventsManagerService.ON_USER_SIGN_OUT = '_onUserSignOut';
    EventsManagerService.ON_USER_SIGN_IN = '_onUserSignIn';
    EventsManagerService.ON_CONNECTION_SETUP = '_onConnectionSetup';
    EventsManagerService.ON_CONNECTIVITY_RECOVERED = '_onConnectivityRecovered';
    EventsManagerService = __decorate([
        Injectable(), 
        __metadata('design:paramtypes', [])
    ], EventsManagerService);
    return EventsManagerService;
}());
//# sourceMappingURL=events-manager.service.js.map