var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { AppConfiguration } from '../common/app-configuration';
import { SyncService } from '../storage/sync.service';
import { DevicesService } from '../resources/devices.service';
var GATEWAY_CHECK_INTERVAL_TIME = 20 * 60 * 1000;
export var GatewayConnectivityService = (function () {
    function GatewayConnectivityService(syncService, devicesService) {
        this.syncService = syncService;
        this.devicesService = devicesService;
    }
    GatewayConnectivityService.prototype.startCheckCycle = function () {
        var _this = this;
        if (!AppConfiguration.currentConfig.currentGateway) {
            if (!this.checkInterval) {
                this.checkGatewayConnectivity();
                this.checkInterval = setInterval(function () {
                    _this.checkGatewayConnectivity();
                }, GATEWAY_CHECK_INTERVAL_TIME);
            }
        }
        else {
            this.stopCheckCycle();
        }
    };
    GatewayConnectivityService.prototype.stopCheckCycle = function () {
        if (this.checkInterval) {
            clearInterval(this.checkInterval);
            this.checkInterval = null;
        }
    };
    GatewayConnectivityService.prototype.checkGatewayConnectivity = function () {
        var _this = this;
        this.devicesService.listAllFromBackend(false, { type: 'gateway' })
            .subscribe(function () {
            _this.syncService.syncChangeSubject.next('devices');
        });
    };
    GatewayConnectivityService = __decorate([
        Injectable(), 
        __metadata('design:paramtypes', [SyncService, DevicesService])
    ], GatewayConnectivityService);
    return GatewayConnectivityService;
}());
//# sourceMappingURL=gateway-connectivity.service.js.map