import 'rxjs/add/operator/catch';
import 'rxjs/add/operator/map';
import 'rxjs/add/observable/throw';
import 'rxjs/add/operator/timeoutWith';
import { AuthService } from "../auth/auth.service";
import { Oauth2Service } from "../resources/oauth-2.service";
import { DevicesService } from "../resources/devices.service";
import { DatabaseService } from "../storage/database.service";
import { EventsManagerService } from "../common/events-manager.service";
import { HttpInterceptor } from "../common/http-interceptor.service";
export declare class LocalConnectionService {
    private http;
    authService: AuthService;
    oauthService: Oauth2Service;
    devicesService: DevicesService;
    database: DatabaseService;
    eventsService: EventsManagerService;
    private usingLocalConnection;
    private apiVersionUrl;
    private switchingConnection;
    constructor(http: HttpInterceptor, authService: AuthService, oauthService: Oauth2Service, devicesService: DevicesService, database: DatabaseService, eventsService: EventsManagerService);
    private startLocalConnectionTimer();
    private testConnections(domains, assignConnection?, refreshToken?);
    checkRemoteConnections(assignRemoteConnection?: boolean, testConnections?: boolean, refreshToken?: boolean): void;
    private checkGateways(localGateways, assignRemoteConnection?, testConnections?, refreshToken?);
    private setNewAPIURL(url, gateway, refreshToken?);
    checkLocalConnection(refreshToken?: boolean): void;
}
