import { Observable } from "rxjs";
export var Model = (function () {
    function Model(service, data) {
        this.service = service;
        this.data = data;
    }
    Object.defineProperty(Model.prototype, "_id", {
        get: function () {
            return this.__id;
        },
        set: function (value) {
            this.__id = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Model.prototype, "name", {
        get: function () {
            return this._data.name || '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Model.prototype, "data", {
        get: function () {
            return this._data;
        },
        set: function (value) {
            var _this = this;
            if (value._id) {
                this._id = value._id;
            }
            if (value && typeof value.toStoreObject === 'function') {
                value = value.toStoreObject();
            }
            var keys = Object.keys(value);
            var _loop_1 = function(i) {
                var key = keys[i];
                if (key != 'data' && key != '_data') {
                    Object.defineProperty(this_1, key, {
                        get: function () {
                            return _this._data[key];
                        },
                        set: function (val) {
                            _this._data[key] = val;
                        }
                    });
                }
            };
            var this_1 = this;
            for (var i = 0; i < keys.length; i++) {
                _loop_1(i);
            }
            this._data = value;
        },
        enumerable: true,
        configurable: true
    });
    Model.prototype.copy = function () {
        return this.service.createModel(this._data);
    };
    Model.prototype.save = function (options) {
        var _this = this;
        return this.service.save(this, options).flatMap(function (saveResponse) {
            _this.data = saveResponse.data;
            return Observable.of(saveResponse);
        });
    };
    Model.prototype.addParent = function (parent) {
        if (!this._data.parents) {
            this._data.parents = {};
        }
        var parentType = parent.service.ResourceName;
        if (!this._data.parents[parentType]) {
            this._data.parents[parentType] = [];
        }
        this._data.parents[parentType].push({ id: parent._id, name: parent.name });
        return this.save();
    };
    Model.prototype.removeParent = function (parent) {
        if (!this._data.parents) {
            return Observable.of(false);
        }
        var parentType = parent.service.ResourceName;
        if (!this._data.parents[parentType]) {
            return Observable.of(false);
        }
        this._data.parents[parentType] = this._data.parents[parentType].filter(function (item) {
            return item.id != parent._id;
        });
        return this.save({ data: { overwriteParents: true } });
    };
    Model.prototype.list = function (query, options) {
        return this.service.list(query, options);
    };
    Model.prototype.remove = function () {
        console.log('remove', this);
        return this.service.removeById(this._id);
    };
    Model.prototype.toStoreObject = function () {
        var copy = Object.assign({}, this._data);
        return copy;
    };
    return Model;
}());
//# sourceMappingURL=model.js.map