import { ConditionModel } from '../models/condition.model';
import { EffectModel } from '../models/effect.model';
import { ControllerModel } from '../models/controller.model';
import { ResponderModel } from '../models/responder.model';
import { DeviceModel } from '../models/device.model';
export declare class NaturalLanguageService {
    private append(desc, value, connector?);
    private plural(value);
    private parseOffset(offset);
    private pluralText(text, val);
    private parseSeconds(secs);
    private appendText(arr);
    private rangeToArray(range);
    private weekString(week);
    private isNumber(n);
    private digits(n);
    private prepend(desc, value, connector?);
    private ordinal(number);
    private monthString(monthIndex);
    private bitmaskToString(bitmask);
    private getConnectorByType(type);
    private getDeviceStateFromType(type, isActive);
    private getDeviceIdFromPath(path?);
    private getComponentName(item);
    private getMethodFromPath(pathStr, onlyParameter);
    private getDeviceName(resource);
    private parseAttributeName(path);
    private parseAttributeCondition(attr, val, deviceName, connector, processorName);
    private getMultipleComponentsName(device, deviceId, processorName, componentId, parents);
    private setDeviceConditionDescription(condition, connector, val, device);
    private parseCrontab(crontab, sunTime?, timezone?, hasFromTo?);
    private convertHoursMinutesToUtc(hours, minutes, offsetTime);
    private getRegularHourFormat(hourUtc);
    private getAmPmByHour(hour);
    private parseDelay(delay);
    private getDeviceMethodFromPath(path);
    private getDeviceAttributeFromPath(path);
    private parseDuration(duration);
    private parseMethod(method, deviceName, value);
    private parseAttribute(attribute, deviceName, value);
    getDateDescription(date: Date, todaysDate: Date): string;
    getConditionDescription(condition: ConditionModel, device?: DeviceModel): string;
    calcTimezone(timezone: any): number;
    parseDateVal(value: any, timeZone: string, onlyTime?: boolean, dateAndTime?: boolean): string;
    parseInterval(interval: String): string;
    getEffectDescription(effect: EffectModel, device?: DeviceModel): string;
    getResponderDescription(responder: ResponderModel, device: DeviceModel): string;
    getDeviceComponentFromPath(path: any): any;
    getDeviceProcessorFromPath(path: any): any;
    getControllerDescription(controller: ControllerModel, device: DeviceModel): string;
    getActionDescription(conditions: [ConditionModel], effects: [EffectModel]): any;
}
