var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
export var NaturalLanguageService = (function () {
    function NaturalLanguageService() {
    }
    NaturalLanguageService.prototype.append = function (desc, value, connector) {
        if (value.toString().length > 0) {
            var sep = desc.length > 0 ? (connector ? ' ' + connector + ' ' : ' ') : '';
            return desc + sep + value;
        }
        return desc;
    };
    NaturalLanguageService.prototype.plural = function (value) {
        if (this.isNumber(value))
            return value > 1 ? 's' : '';
        return '';
    };
    NaturalLanguageService.prototype.parseOffset = function (offset) {
        var desc = '';
        if (this.isNumber(offset) && offset != 0) {
            return this.parseSeconds(Math.abs(offset)) + (offset > 0 ? ' after' : ' before');
        }
        return desc;
    };
    NaturalLanguageService.prototype.pluralText = function (text, val) {
        if (val > 1) {
            return text + 's';
        }
        return text;
    };
    NaturalLanguageService.prototype.parseSeconds = function (secs) {
        var desc = '';
        if (secs < 60) {
            desc = secs + ' ' + this.pluralText('sec', secs);
        }
        else if (secs >= 60) {
            var remainingSecs = secs % 60;
            var minutes = Math.floor(secs / 60);
            var remainingMinutes = minutes % 60;
            var hours = Math.floor(minutes / 60);
            desc += this.digits(remainingSecs);
            if (hours == 0) {
                if (remainingMinutes > 0 && remainingSecs > 0) {
                    return remainingMinutes + ':' + this.digits(remainingSecs) + ' ' + this.pluralText('min', minutes);
                }
                else if (remainingMinutes > 0 && remainingSecs == 0) {
                    return remainingMinutes + ' ' + this.pluralText('min', minutes);
                }
                else {
                    return remainingSecs + ' ' + this.pluralText('sec', remainingSecs);
                }
            }
            else {
                if (remainingMinutes == 0 && remainingSecs == 0) {
                    return hours + ' ' + this.pluralText('hour', hours);
                }
                else {
                    return hours + ':' + this.digits(remainingMinutes) + ':' + this.digits(remainingSecs) + ' ' + this.pluralText('hour', hours);
                }
            }
        }
        return desc;
    };
    NaturalLanguageService.prototype.appendText = function (arr) {
        if (arr.length == 1) {
            return arr[0];
        }
        var last = arr.pop();
        return arr.join(', ') + ' and ' + last;
    };
    NaturalLanguageService.prototype.rangeToArray = function (range) {
        var res = null;
        var sp;
        var i;
        if (range.indexOf('-') >= 0) {
            sp = range.split('-');
            if (sp.length > 1) {
                res = [];
                for (i = parseInt(sp[0]); i <= parseInt(sp[1]); i++) {
                    res.push(i);
                }
            }
        }
        else if (range.indexOf(',') >= 0) {
            sp = range.split(',');
            if (sp.length > 0) {
                res = [];
                for (i = 0; i < sp.length; i++) {
                    res.push(parseInt(sp[i]));
                }
            }
        }
        else if (this.isNumber(range)) {
            res = [parseInt(range)];
        }
        return res;
    };
    NaturalLanguageService.prototype.weekString = function (week) {
        var desc = '';
        if (week == '1-5' || week == '1,2,3,4,5') {
            desc = 'on weekdays';
        }
        else if (week == '0-6' || week == '0,1,2,3,4,5,6' || week == '1,2,3,4,5,6,7' || week == '1-7' || week == '1,2,3,4,5,6,0') {
            desc = 'every day';
        }
        else if (week == '6-7' || week == '0,6' || week == '6,7') {
            desc = 'on weekends';
        }
        else {
            var daysInWeek = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'];
            var arr = this.rangeToArray(week);
            if (arr) {
                desc = this.append(desc, 'on');
                var selectedDays = [];
                for (var i = 0; i < arr.length; i++) {
                    if (arr[i] < daysInWeek.length) {
                        selectedDays.push(daysInWeek[arr[i]]);
                    }
                }
                desc = this.append(desc, this.appendText(selectedDays));
            }
        }
        return desc;
    };
    NaturalLanguageService.prototype.isNumber = function (n) {
        return !isNaN(parseFloat(n)) && isFinite(n);
    };
    NaturalLanguageService.prototype.digits = function (n) {
        return n < 10 ? '0' + n : n;
    };
    NaturalLanguageService.prototype.prepend = function (desc, value, connector) {
        var sep = desc.length > 0 ? (connector ? ' ' + connector + ' ' : ' ') : '';
        return value + sep + desc;
    };
    NaturalLanguageService.prototype.ordinal = function (number) {
        var desc = '';
        if (number % 10 == 1) {
            desc = 'st';
        }
        else if (number % 10 == 2) {
            desc = 'nd';
        }
        else if (number % 10 == 3) {
            desc = 'rd';
        }
        else {
            desc = 'th';
        }
        return number + desc;
    };
    NaturalLanguageService.prototype.monthString = function (monthIndex) {
        var mL = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
        return mL[monthIndex];
    };
    NaturalLanguageService.prototype.bitmaskToString = function (bitmask) {
        return (bitmask >>> 0).toString(2);
    };
    NaturalLanguageService.prototype.getConnectorByType = function (type) {
        type = type.toLowerCase();
        var isDetects = type.indexOf('motion') > -1 ||
            type.indexOf('leak') > -1 ||
            type.indexOf('smoke') > -1 ||
            type.indexOf('fire') > -1 ||
            type.indexOf('water') > -1 ||
            type.indexOf('vibration') > -1 ||
            type.indexOf('carbon') > -1 ||
            type.indexOf('glass') > -1;
        var isIs = type.indexOf('contact') > -1 ||
            type.indexOf('remote') > -1 ||
            type.indexOf('key fob') > -1 ||
            type.indexOf('keypad') > -1 ||
            type.indexOf('personal') > -1 ||
            type.indexOf('standard warning') > -1;
        if (isDetects) {
            return 'detects';
        }
        else if (isIs) {
            return 'is';
        }
        return 'matches';
    };
    NaturalLanguageService.prototype.getDeviceStateFromType = function (type, isActive) {
        type = type.toLowerCase();
        if (type.indexOf('motion') > -1) {
            return isActive ? 'Motion' : 'No Motion';
        }
        else if (type.indexOf('leak') > -1) {
            return isActive ? 'Leak' : 'No Leak';
        }
        else if (type.indexOf('smoke') > -1) {
            return isActive ? 'Smoke' : 'No Smoke';
        }
        else if (type.indexOf('fire') > -1) {
            return isActive ? 'Fire' : 'No Fire';
        }
        else if (type.indexOf('water') > -1) {
            return isActive ? 'Water' : 'No Water';
        }
        else if (type.indexOf('vibration') > -1) {
            return isActive ? 'Vibration' : 'No Vibration';
        }
        else if (type.indexOf('carbon') > -1) {
            return isActive ? 'CO' : 'No CO';
        }
        else if (type.indexOf('glass') > -1) {
            return isActive ? 'Glass break' : 'No Glass break';
        }
        else if (type.indexOf('contact') > -1) {
            return isActive ? 'Open' : 'Closed';
        }
        else if (type.indexOf('standard warning') > -1) {
            return 'warning';
        }
        else if (type.indexOf('personal') > -1) {
            return 'emergency';
        }
        else if (type.indexOf('remote') > -1) {
            return 'emergency';
        }
        else if (type.indexOf('key fob') > -1) {
            return 'emergency';
        }
        else if (type.indexOf('keypad') > -1) {
            return 'emergency';
        }
        return '';
    };
    NaturalLanguageService.prototype.getDeviceIdFromPath = function (path) {
        // /devices/582a1bddad04460fe3ac527a/comps/1/procs/OnOff/methods/On
        if (path === void 0) { path = ''; }
        var split = path.split('/');
        if (split.length > 2 && split[1] == 'devices') {
            return split[2];
        }
        return null;
    };
    NaturalLanguageService.prototype.getComponentName = function (item) {
        if (item.componentName && item.componentName.length > 0) {
            return item.componentName;
        }
    };
    NaturalLanguageService.prototype.getMethodFromPath = function (pathStr, onlyParameter) {
        var METHODS_DIR = '/methods/';
        var position = onlyParameter ? 1 : 0;
        var path = pathStr || '';
        var hasMethodsDir = path.indexOf(METHODS_DIR) > -1;
        var method;
        if (hasMethodsDir) {
            method = path
                .split(METHODS_DIR)[1]
                .split('.')[position];
        }
        if (method) {
            method = method.replace(/([A-Z])/g, ' $1').trim();
        }
        return method;
    };
    NaturalLanguageService.prototype.getDeviceName = function (resource) {
        if (resource.path && resource.parents && Array.isArray(resource.parents.devices)) {
            var deviceId = this.getDeviceIdFromPath(resource.path);
            if (deviceId) {
                for (var i = 0; i < resource.parents.devices.length; i++) {
                    var parent_1 = resource.parents.devices[i];
                    if (parent_1.id.toString() == deviceId) {
                        return parent_1.name;
                    }
                }
            }
        }
        return null;
    };
    NaturalLanguageService.prototype.parseAttributeName = function (path) {
        var attributeName = 'attribute';
        // /devices/582a1bddad04460fe3ac527a/comps/1/procs/OnOff/attrs/On
        var arr = path.split('/');
        if (arr.length >= 8 && arr[7] == 'attrs') {
            if (arr[8].indexOf('.') >= 0) {
                var sp = arr[8].split('.');
                attributeName = sp[0];
            }
            else {
                attributeName = arr[8];
            }
            attributeName = attributeName.replace(/([A-Z])/g, ' $1').trim();
        }
        return attributeName;
    };
    NaturalLanguageService.prototype.parseAttributeCondition = function (attr, val, deviceName, connector, processorName) {
        var desc = '';
        var attrStr = attr.toLowerCase();
        if (attrStr == 'on off') {
            if (parseInt(val) == 1 || val == 'on' || val == true) {
                desc = deviceName + ' is On';
            }
            else {
                desc = deviceName + ' is Off';
            }
        }
        else if (attrStr === 'lock state') {
            if (parseInt(val) == 1 || val == 'locked' || val == true) {
                desc = deviceName + ' is Locked';
            }
            else {
                desc = deviceName + ' is Unlocked';
            }
        }
        else if (attrStr == 'current level') {
            desc = deviceName + ' state ' + connector + ' ' + val + '%';
        }
        else if (attrStr == 'measured value' && processorName === 'RelativeHumidityMeasurementServer') {
            desc = deviceName + ' Humidity ' + connector + ' ' + val + '%';
        }
        else if (attrStr == 'measured value' && processorName === 'TemperatureMeasurementServer') {
            desc = deviceName + ' Temperature ' + connector + ' ' + val + '°C';
        }
        else if (attrStr === 'current summation delivered value') {
            desc = deviceName + ' Energy ' + connector + ' ' + val + ' kWh';
        }
        else if (attrStr === 'instantaneous demand value') {
            desc = deviceName + ' Power ' + connector + ' ' + val + ' kW';
        }
        else if (attrStr === 'voltage') {
            desc = deviceName + ' Voltage ' + connector + ' ' + val + '-Volts';
        }
        else if (attrStr === 'current') {
            desc = deviceName + ' Current ' + connector + ' ' + val + '-Amps';
        }
        else if (attrStr === 'frequency') {
            desc = deviceName + ' Frequency ' + connector + ' ' + val + '-Hz';
        }
        else if (attrStr === 'active power') {
            desc = deviceName + ' Power ' + connector + ' ' + val + '-Watts';
        }
        else if (attrStr === 'battery percentage remaining') {
            desc = deviceName + ' battery ' + connector + ' ' + val + '%';
        }
        else if (attrStr === 'local temperature') {
            desc = deviceName + ' Temperature ' + connector + ' ' + val + '°C';
        }
        else if (attrStr === 'system mode') {
            var idx = parseInt(val);
            var modes = ['Off', 'Auto', undefined, 'Cool', 'Heat'];
            var mode = modes[idx] || '';
            desc = deviceName + ' mode is set to ' + mode;
        }
        else if (attrStr === 'fan mode') {
            var idx = parseInt(val);
            var modes = ['Off', 'Low', 'Medium', 'High', 'On', 'Auto', 'Smart'];
            var mode = modes[idx] || '';
            desc = deviceName + ' fan is set to ' + mode;
        }
        else if (attrStr === 'zone status') {
            if (val === 'emergency') {
                desc = 'Emergency button is pressed on ' + deviceName;
            }
            else if (val === 'warning') {
                desc = deviceName + ' sends Alert ';
            }
            else {
                desc = deviceName + ' ' + connector + ' ' + val;
            }
        }
        else if (attrStr.indexOf('setpoint') > -1) {
            if (attrStr.indexOf('heat') > -1) {
                desc = deviceName + ' heating setpoint ' + connector + ' ' + val + 'ºC';
            }
            else {
                desc = deviceName + ' cooling setpoint ' + connector + ' ' + val + 'ºC';
            }
        }
        else if (processorName === 'OnOffClient') {
            desc = 'Button ' + val + ' is Pressed on ' + deviceName;
        }
        else if (processorName === 'IASWDClient') {
            desc = 'Button is Pressed on ' + deviceName;
        }
        else {
            desc = attr + ' in ' + deviceName + ' ' + connector + ' ' + val;
        }
        return desc;
    };
    NaturalLanguageService.prototype.getMultipleComponentsName = function (device, deviceId, processorName, componentId, parents) {
        var deviceName = '';
        if (device) {
            deviceName = device.name ? device.name : 'device ' + device._id;
            if (device.components) {
                var components = [];
                for (var i = 0; i < device.components.length; i++) {
                    var component = device.components[i];
                    if (component && component.processors) {
                        for (var j = 0; j < component.processors.length; j++) {
                            var processor = component.processors[j];
                            if (processor && processor.name == processorName) {
                                components.push(component);
                            }
                        }
                    }
                }
                if (components.length > 1) {
                    var component = components.find(function (it) {
                        return it.id == componentId;
                    });
                    if (component) {
                        deviceName = deviceName + ' ' + component.name;
                    }
                }
            }
        }
        else if (parents && parents.devices) {
            var parentDevice = parents.devices.find(function (item) {
                return deviceId == item.id;
            });
            if (parentDevice && parentDevice.name) {
                deviceName = parentDevice.name;
            }
            else {
                deviceName = 'device ' + deviceId;
            }
        }
        else if (deviceId) {
            deviceName = 'device ' + deviceId;
        }
        return deviceName;
    };
    NaturalLanguageService.prototype.setDeviceConditionDescription = function (condition, connector, val, device) {
        var description = '';
        if (condition.path && condition.type == 'device-state') {
            var attr = this.parseAttributeName(condition.path);
            var methodParam = this.getMethodFromPath(condition.path, true);
            var deviceId = this.getDeviceIdFromPath(condition.path);
            var processorName = this.getDeviceProcessorFromPath(condition.path);
            var componentId = this.getDeviceComponentFromPath(condition.path);
            attr = attr === 'attribute' && methodParam ? methodParam : attr;
            if (deviceId) {
                var deviceName = this.getMultipleComponentsName(device, deviceId, processorName, componentId, condition.parents);
                var supportedConnector = 'is equal to' === connector ||
                    'is above' === connector ||
                    'is below' === connector ||
                    'is' === connector ||
                    'detects' === connector;
                if (supportedConnector) {
                    description = this.append(description, 'when ' + this.parseAttributeCondition(attr, val, deviceName, connector, processorName));
                }
                else {
                    description = this.append(description, 'when ' + attr + ' in ' + deviceName + ' ' + connector + ' ' + val);
                }
            }
        }
        return description;
    };
    NaturalLanguageService.prototype.parseCrontab = function (crontab, sunTime, timezone, hasFromTo) {
        var desc = '';
        var parts = crontab.split(' ');
        if (parts.length >= 5) {
            var minutes = parts[0];
            var hours = parts[1];
            var date = parts[2];
            var month = parts[3];
            var week = parts[4];
            var offsetTime = this.calcTimezone(timezone);
            var innerDate = void 0;
            if (date == '*' && week == '*') {
                if (minutes != '*' || hours != '*') {
                    var _a = this.convertHoursMinutesToUtc(hours, minutes, offsetTime), hrsUtc = _a.hrsUtc, minsUtc = _a.minsUtc;
                    var hrs = this.getRegularHourFormat(hrsUtc);
                    var amPm = this.getAmPmByHour(hrsUtc);
                    desc = this.append(desc, 'every day at ' + hrs + ':' + this.digits(minsUtc) + ' ' + amPm);
                    if (month != '*') {
                        desc = this.append(desc, 'during ' + this.monthString(parseInt(month)));
                    }
                    return desc;
                }
            }
            if (!sunTime) {
                if (minutes != '*' && hours != '*' && !hasFromTo) {
                    var _b = this.convertHoursMinutesToUtc(hours, minutes, offsetTime), hrsUtc = _b.hrsUtc, minsUtc = _b.minsUtc;
                    var hrs = this.getRegularHourFormat(hrsUtc);
                    var amPm = this.getAmPmByHour(hrsUtc);
                    if (parseInt(hours) != 0) {
                        desc = this.append(desc, 'at ' + hrs + ':' + this.digits(minsUtc) + ' ' + amPm);
                    }
                }
                else if (hours == '*' && minutes == '0' && !hasFromTo) {
                    desc = desc.length > 0 ? this.append(desc, 'every hour') : this.append(desc, 'hourly');
                }
                else if (hours == '*' && minutes != '*' && !hasFromTo) {
                    innerDate = new Date(parseInt(minutes) * 60 * 1000);
                    innerDate.setTime(innerDate.getTime() + offsetTime);
                    minutes = innerDate.getUTCMinutes();
                    desc = this.append(desc, 'every ' + (parseInt(minutes) != 1 ? minutes + ' ' : '') + this.pluralText('minute', parseInt(minutes)));
                }
            }
            if (week != '*' && date.indexOf('/2') < 0) {
                var weekStr = this.weekString(week);
                desc = this.prepend(desc, weekStr);
            }
            else if (week === '*' && date.indexOf('/2') < 0) {
                desc = this.prepend(desc, 'every day');
            }
            if (date === '1-31/2') {
                desc = this.prepend(desc, 'on odd dates, ');
            }
            else if (date === '0-30/2') {
                desc = this.prepend(desc, 'on even dates, ');
            }
            else if (date !== '*') {
                desc = this.append(desc, 'each ' + this.ordinal(parseInt(date)) + (month == '*' ? ' day of the month' : ''));
            }
            if (month != '*') {
                desc = this.append(desc, 'during ' + this.monthString(parseInt(month)));
            }
        }
        return desc;
    };
    NaturalLanguageService.prototype.convertHoursMinutesToUtc = function (hours, minutes, offsetTime) {
        var innerDate = new Date((parseInt(hours) * 60 * 60 + parseInt(minutes) * 60) * 1000);
        innerDate.setTime(innerDate.getTime() + offsetTime);
        var hrsUtc = innerDate.getUTCHours();
        return {
            hrsUtc: innerDate.getUTCHours(),
            minsUtc: innerDate.getUTCMinutes()
        };
    };
    NaturalLanguageService.prototype.getRegularHourFormat = function (hourUtc) {
        if (hourUtc >= 12) {
            hourUtc = hourUtc - 12;
        }
        if (hourUtc === 0) {
            hourUtc = 12;
        }
        return hourUtc;
    };
    NaturalLanguageService.prototype.getAmPmByHour = function (hour) {
        var dd = 'AM';
        if (hour >= 12) {
            dd = 'PM';
        }
        return dd;
    };
    NaturalLanguageService.prototype.parseDelay = function (delay) {
        if (this.isNumber(delay)) {
            if (delay < 60) {
                return delay + ' secs';
            }
            else if (delay >= 60) {
                return this.parseSeconds(delay);
            }
        }
    };
    NaturalLanguageService.prototype.getDeviceMethodFromPath = function (path) {
        // /devices/582a1bddad04460fe3ac527a/comps/1/procs/OnOff/methods/On
        var split = path.split('/');
        if (split.length >= 8 && split[1] == 'devices' && split[7] == 'methods') {
            return split[8];
        }
        return null;
    };
    NaturalLanguageService.prototype.getDeviceAttributeFromPath = function (path) {
        // /devices/582a1bddad04460fe3ac527a/comps/1/procs/OnOff/methods/On
        var split = path.split('/');
        if (split.length >= 8 && split[1] == 'devices' && split[7] == 'attrs') {
            return split[8];
        }
        return null;
    };
    NaturalLanguageService.prototype.parseDuration = function (duration) {
        // console.log("Duration: ",duration);
        var hours = Math.floor(duration / 3600);
        duration %= 3600;
        var minutes = Math.floor(duration / 60);
        var seconds = duration % 60;
        var desc = " for ";
        if (hours > 0) {
            desc += String(hours) + (hours > 1 ? ' hrs' : " hr");
        }
        if (minutes > 0) {
            desc += (hours > 0 ? " " : "") + String(minutes) + (minutes > 1 ? ' mins' : " min");
        }
        if (seconds > 0) {
            if (hours > 0 || minutes > 0) {
                desc += " ";
            }
            desc += String(seconds) + (seconds > 1 ? ' secs' : " sec");
        }
        if ((seconds == 0) && (hours == 0) && (minutes == 0)) {
            desc = "";
        }
        return desc;
    };
    NaturalLanguageService.prototype.parseMethod = function (method, deviceName, value) {
        var desc;
        var lowerCaseMethod = method.toLowerCase();
        if (lowerCaseMethod.indexOf('on') == 0 || lowerCaseMethod.indexOf('off') == 0) {
            desc = 'turn ' + method + ' ' + deviceName;
        }
        else if (lowerCaseMethod.indexOf('toggle') == 0) {
            desc = method + ' ' + deviceName;
        }
        else if (lowerCaseMethod.indexOf('movetolevel') == 0 && value.value != null) {
            desc = 'set ' + deviceName + ' to ' + value.value + '%';
        }
        else if (lowerCaseMethod.indexOf('unlockdoor') == 0) {
            desc = 'Unlock ' + deviceName;
        }
        else if (lowerCaseMethod.indexOf('lockdoor') == 0) {
            desc = 'Lock ' + deviceName;
        }
        else if (lowerCaseMethod.indexOf('startwarning') == 0) {
            // console.log("start warning value is:", value);
            if (value.Mode == 0) {
                desc = 'Stop warning on ' + deviceName;
            }
            else {
                desc = 'Start warning on ' + deviceName + this.parseDuration(value.Duration);
            }
        }
        else if (lowerCaseMethod.indexOf('sendemail') == 0) {
            desc = 'Send Email';
        }
        else if (lowerCaseMethod.indexOf('notification') > -1) {
            desc = 'Send Push Notification';
        }
        else {
            desc = 'execute ' + method + ' on ' + deviceName;
        }
        return desc;
    };
    NaturalLanguageService.prototype.parseAttribute = function (attribute, deviceName, value) {
        var desc;
        var valueStr = value && value.value;
        var lowerCaseAttribute = attribute.toLowerCase();
        if (lowerCaseAttribute.indexOf('onoff') == 0) {
            desc = 'turn ' + (valueStr ? 'On' : 'Off') + ' ' + deviceName;
        }
        else if (lowerCaseAttribute.indexOf('currentlevel') == 0) {
            desc = 'set ' + deviceName + ' to ' + valueStr + '%';
        }
        else if (lowerCaseAttribute.indexOf('systemmode') == 0) {
            // console.log('is system mode');
            desc = 'set ' + deviceName + ' to ';
            if (valueStr == 0)
                desc += "off";
            else if (valueStr == 1)
                desc += "auto";
            else if (valueStr == 3)
                desc += "cool";
            else if (valueStr == 4)
                desc += "heat";
        }
        else if (lowerCaseAttribute.indexOf('setpoint') > -1) {
            // console.log('is set points');
            if (lowerCaseAttribute.indexOf('heat') > -1) {
                desc = 'set ' + deviceName + ' heating setpoint to ' + valueStr + 'ºC';
            }
            else {
                desc = 'set ' + deviceName + ' cooling setpoint to ' + valueStr + 'ºC';
            }
        } /*else if (lowerCaseAttribute.indexOf('fanmode') == 0 && valueStr) {
          desc = 'set ' + deviceName + ' to ';
          if(valueStr == 0) desc += "off";
          else if(valueStr == 1) desc += "auto";
          else if(valueStr == 3) desc += "cool";
          else if(valueStr == 4) desc += "heat";
        }*/
        else {
            desc = 'set ' + attribute + ' to ' + valueStr + ' on ' + deviceName;
        }
        return desc;
    };
    NaturalLanguageService.prototype.getDateDescription = function (date, todaysDate) {
        var desc = '';
        if (date && date.getHours && date.getMinutes && date.getDate && date.getMonth) {
            desc = 'at ' + date.getHours() + ':' + this.digits(date.getMinutes());
            if (date.getDate() == todaysDate.getDate()) {
                desc += ', Today';
            }
            else {
                desc += ', ' + this.monthString(date.getMonth()) + ' ' + this.ordinal(date.getDate());
            }
        }
        return desc;
    };
    NaturalLanguageService.prototype.getConditionDescription = function (condition, device) {
        var description = '';
        if (condition && condition.value != undefined) {
            var val = condition.value;
            var parsedEqual = false;
            if (val.hasOwnProperty('#crontab')) {
                var hasFromTo = val.hasOwnProperty('#from') || val.hasOwnProperty('#to');
                if (val.hasOwnProperty('#eval') && (val['#eval'] == 'sunset' || val['#eval'] == 'sunrise')) {
                    parsedEqual = true;
                    if (val.hasOwnProperty('#offset')) {
                        var parsedOffset = this.parseOffset(val['#offset']);
                        description = this.append(description, parsedOffset);
                        description = this.append(description, !parsedOffset ? 'at ' + val['#eval'] : val['#eval']);
                    }
                    else {
                        description = this.append(description, 'at ' + val['#eval']);
                    }
                    description = this.prepend(description, this.parseCrontab(val['#crontab'], true, val['#tz'], hasFromTo));
                    description = description && description.trim();
                }
                else {
                    description = this.append(description, this.parseCrontab(val['#crontab'], false, val['#tz'], hasFromTo));
                }
            }
            if (condition.path && condition.type == 'device-state') {
                if (typeof val === 'string') {
                    description = this.append(description, this.setDeviceConditionDescription(condition, 'is equal to', val, device));
                }
                else if (val.hasOwnProperty('#eq')) {
                    description = this.append(description, this.setDeviceConditionDescription(condition, 'is equal to', val['#eq'], device));
                }
                if (val.hasOwnProperty('#gt')) {
                    description = this.append(description, this.setDeviceConditionDescription(condition, 'is above', val['#gt'], device));
                }
                if (val.hasOwnProperty('#gte')) {
                    description = this.append(description, this.setDeviceConditionDescription(condition, 'is greater or equal to', val['#gte'], device));
                }
                if (val.hasOwnProperty('#lt')) {
                    description = this.append(description, this.setDeviceConditionDescription(condition, 'is below', val['#lt'], device));
                }
                if (val.hasOwnProperty('#lte')) {
                    description = this.append(description, this.setDeviceConditionDescription(condition, 'is lower or equal to', val['#lte'], device));
                }
                if (val.hasOwnProperty('#ne')) {
                    description = this.append(description, this.setDeviceConditionDescription(condition, 'is different from', val['#ne'], device));
                }
                if (val.hasOwnProperty('#regex')) {
                    description = this.append(description, this.setDeviceConditionDescription(condition, 'matches', '"' + val['#regex'] + '"', device));
                }
                if (val.hasOwnProperty('#bitmask')) {
                    var type = val['#type'];
                    if (type) {
                        var isActive = !val.hasOwnProperty('#expected');
                        var connector = this.getConnectorByType(type);
                        var deviceState = this.getDeviceStateFromType(type, isActive);
                        description = this.append(description, this.setDeviceConditionDescription(condition, connector, deviceState, device));
                    }
                    else {
                        description = this.append(description, this.setDeviceConditionDescription(condition, 'is equal to', this.bitmaskToString(val['#bitmask']), device));
                    }
                }
            }
            else {
                if (!parsedEqual && typeof val === 'string') {
                    description = this.append(description, 'at ' + val);
                }
                if (!parsedEqual && val.hasOwnProperty('#eq')) {
                    var equalValue = val['#eq'];
                    var timeZone = val['#tz'];
                    if (timeZone) {
                        var timeValue = this.parseDateVal(equalValue, timeZone, true, false);
                        description = this.append(description, 'at ' + timeValue);
                    }
                    else {
                        description = this.append(description, 'at ' + equalValue);
                    }
                }
                if (val.hasOwnProperty('#random')) {
                    description = this.append(description, 'randomly');
                }
                if (val.hasOwnProperty('#interval')) {
                    description = this.append(description, this.parseInterval(val['#interval']));
                }
                if (val.hasOwnProperty('#from') && !val.hasOwnProperty('#to')) {
                    var fromValueHasDatetime = val['#fromHasDatetime'];
                    description = this.append(description, 'starting on ' + this.parseDateVal(val['#from'], val['#tz'], false, fromValueHasDatetime));
                }
                if (val.hasOwnProperty('#from') && val.hasOwnProperty('#to')) {
                    var fromValueHasDatetime = val['#fromHasDatetime'];
                    var toValueHasDatetime = val['#toHasDatetime'];
                    var timeZone = val['#tz'];
                    var fromValue = val['#from'];
                    var toValue = val['#to'];
                    var fromValueOnlyTime = isNaN(Date.parse(fromValue));
                    var toValueOnlyTime = isNaN(Date.parse(toValue));
                    var from = this.parseDateVal(fromValue, timeZone, fromValueOnlyTime, fromValueHasDatetime);
                    var to = this.parseDateVal(toValue, timeZone, toValueOnlyTime, toValueHasDatetime);
                    description = this.append(description, 'between ' + from + ' and ' + to);
                }
                if (val.hasOwnProperty('#period')) {
                    description = this.append(description, 'every ' + val['#period'] + ' sec' + this.plural(val['#period']));
                }
                if (val.hasOwnProperty('#regex')) {
                    description = this.append(description, 'time matches' + ' "' + val['#regex'] + '"');
                }
            }
        }
        // console.log('[SDK getConditionDescription]', condition);
        return description.charAt(0).toUpperCase() + description.substr(1);
    };
    NaturalLanguageService.prototype.calcTimezone = function (timezone) {
        var offsetTime = 0;
        if (timezone && timezone.length > 0) {
            var offset = timezone.split(':');
            if (offset && offset.length > 1) {
                var offsetHours = parseInt(offset[0]);
                var offsetMinutes = parseInt(offset[1]);
                offsetTime = (offsetHours * 60 + offsetMinutes) * 60 * 1000;
            }
        }
        return offsetTime;
    };
    NaturalLanguageService.prototype.parseDateVal = function (value, timeZone, onlyTime, dateAndTime) {
        var date = '';
        var offsetTime = this.calcTimezone(timeZone);
        var parsedDate = Date.parse(value);
        if (isNaN(parsedDate)) {
            if (value.indexOf(':') >= 0) {
                var parsedTime = value.split(':');
                var dateHours = parseInt(parsedTime[0]);
                var dateMinutes = parseInt(parsedTime[1]);
                var innerDate = new Date((dateHours * 60 + dateMinutes) * 60 * 1000);
                innerDate.setTime(innerDate.getTime() + offsetTime);
                var hrsUtc = innerDate.getUTCHours();
                var minsUtc = innerDate.getUTCMinutes();
                var hrs = this.getRegularHourFormat(hrsUtc);
                var amPm = this.getAmPmByHour(hrsUtc);
                date = hrs + ':' + this.digits(minsUtc) + ' ' + amPm;
            }
        }
        else {
            var innerDate = new Date(Date.parse(value));
            innerDate.setTime(innerDate.getTime() + offsetTime);
            var hrsUtc = innerDate.getUTCHours();
            var minsUtc = innerDate.getUTCMinutes();
            var hrs = this.getRegularHourFormat(hrsUtc);
            var amPm = this.getAmPmByHour(hrsUtc);
            if (onlyTime) {
                try {
                    date = hrs + ':' + this.digits(minsUtc) + ' ' + amPm;
                }
                catch (err) {
                    date = value;
                }
            }
            else {
                try {
                    var monthUtc = innerDate.getUTCMonth();
                    var dateUtc = innerDate.getUTCDate();
                    var yearUtc = innerDate.getUTCFullYear();
                    date = this.monthString(monthUtc) + ' ' + this.ordinal(dateUtc) + ' ' + yearUtc;
                }
                catch (err) {
                    date = value;
                }
            }
            if (dateAndTime && !isNaN(parsedDate)) {
                date = this.append(date, ' at ' + hrs + ':' + this.digits(minsUtc) + ' ' + amPm);
            }
        }
        return date;
    };
    NaturalLanguageService.prototype.parseInterval = function (interval) {
        var split = interval.split(' ');
        var desc = '';
        if (split && split.length >= 3) {
            var days = split[0];
            var hours = split[1];
            var minutes = split[2];
            var hoursDesc = '';
            var minutesDesc = '';
            var secsDesc = '';
            if (days && days != 0) {
                desc = 'repeating every ';
                if (days == 1) {
                    hoursDesc = 'day';
                }
                else {
                    hoursDesc = days + ' days';
                }
            }
            if (hours && hours != 0) {
                desc = 'repeating every ';
                if (hours == 1) {
                    minutesDesc = 'hour';
                }
                else {
                    minutesDesc = hours + ' hours';
                }
            }
            if (minutes && minutes != 0) {
                desc = 'repeating every ';
                if (minutes == 1) {
                    secsDesc = 'minute';
                }
                else {
                    secsDesc = minutes + ' minutes';
                }
            }
            var arr = [hoursDesc, minutesDesc, secsDesc].filter(function (item) {
                return item.length > 0;
            });
            if (arr.length === 1) {
                desc += arr[0] + ',';
            }
            else if (arr.length === 2) {
                desc += arr.join(' and ') + ',';
            }
            else if (arr.length === 3) {
                desc += arr[0] + ', ' + arr[1] + ' and ' + arr[2] + ',';
            }
        }
        return desc;
    };
    NaturalLanguageService.prototype.getEffectDescription = function (effect, device) {
        var desc = '';
        var deviceId = this.getDeviceIdFromPath(effect.path);
        var processorName = this.getDeviceProcessorFromPath(effect.path);
        var componentId = this.getDeviceComponentFromPath(effect.path);
        if (effect.delay) {
            desc = this.append(desc, 'after ' + this.parseDelay(effect.delay) + ',');
        }
        if (deviceId) {
            var deviceName = this.getMultipleComponentsName(device, deviceId, processorName, componentId, effect.parents);
            var method = this.getDeviceMethodFromPath(effect.path);
            var attribute = this.getDeviceAttributeFromPath(effect.path);
            if (method) {
                var parsedMethod = this.parseMethod(method, deviceName, effect.params);
                desc = this.append(desc, parsedMethod);
            }
            else if (attribute) {
                var parsedAttribute = this.parseAttribute(attribute, deviceName, effect.params);
                desc = this.append(desc, parsedAttribute);
            }
            else {
                desc = this.append(desc, 'execute method');
                desc = this.append(desc, deviceName, 'on');
            }
        }
        // console.log('[SDK getEffectDescription]', effect);
        return desc.charAt(0).toUpperCase() + desc.substr(1);
    };
    NaturalLanguageService.prototype.getResponderDescription = function (responder, device) {
        var desc = '';
        var deviceId = this.getDeviceIdFromPath(responder.path);
        var processorName = this.getDeviceProcessorFromPath(responder.path);
        var componentId = this.getDeviceComponentFromPath(responder.path);
        if (deviceId) {
            var deviceName = this.getMultipleComponentsName(device, deviceId, processorName, componentId, responder.parents);
            var method = this.getDeviceMethodFromPath(responder.path);
            var attribute = this.getDeviceAttributeFromPath(responder.path);
            if (method) {
                var parsedMethod = this.parseMethod(method, deviceName, responder.params);
                desc = this.append(desc, parsedMethod);
            }
            else if (attribute) {
                var parsedAttribute = this.parseAttribute(attribute, deviceName, responder.params);
                desc = this.append(desc, parsedAttribute);
            }
            else {
                desc = this.append(desc, 'execute method');
                desc = this.append(desc, deviceName, 'on');
            }
        }
        return desc.charAt(0).toUpperCase() + desc.substr(1);
    };
    NaturalLanguageService.prototype.getDeviceComponentFromPath = function (path) {
        // /devices/582a1bddad04460fe3ac527a/comps/1/procs/OnOff/methods/On
        if (path) {
            var split = path.split('/');
            if (split.length >= 8 && split[1] == 'devices' && split[3] == 'comps') {
                return split[4];
            }
        }
        return null;
    };
    NaturalLanguageService.prototype.getDeviceProcessorFromPath = function (path) {
        // /devices/582a1bddad04460fe3ac527a/comps/1/procs/OnOff/methods/On
        if (path) {
            var split = path.split('/');
            if (split.length >= 7 && split[1] == 'devices' && split[5] == 'procs') {
                return split[6];
            }
        }
        return null;
    };
    NaturalLanguageService.prototype.getControllerDescription = function (controller, device) {
        var desc = '';
        var deviceId = this.getDeviceIdFromPath(controller.path);
        var processorName = this.getDeviceProcessorFromPath(controller.path);
        var componentId = this.getDeviceComponentFromPath(controller.path);
        if (deviceId) {
            var deviceName = this.getMultipleComponentsName(device, deviceId, processorName, componentId, controller.parents);
            var componentName = this.getComponentName(controller) || 'button';
            if (processorName && processorName.toLowerCase() == 'onoffclient') {
                return 'When ' + deviceName + ' ' + componentName + ' is Pressed';
            }
            return desc;
        }
        return desc.charAt(0).toUpperCase() + desc.substr(1);
    };
    NaturalLanguageService.prototype.getActionDescription = function (conditions, effects) {
        var description = { conditions: [], effects: [] };
        for (var i = 0; i < conditions.length; i++) {
            description.conditions.push(conditions[i].description);
        }
        for (var i = 0; i < effects.length; i++) {
            description.effects.push(effects[i].description);
        }
        return description;
    };
    NaturalLanguageService = __decorate([
        Injectable(), 
        __metadata('design:paramtypes', [])
    ], NaturalLanguageService);
    return NaturalLanguageService;
}());
//# sourceMappingURL=natural-language.service.js.map