var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import 'paho-mqtt';
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { LocalStorageModule } from 'angular-2-local-storage';
import { StorageService } from './storage/storage.service';
import { AuthService } from './auth/auth.service';
import { EventsManagerService } from './common/events-manager.service';
import { Oauth2Service } from './resources/oauth-2.service';
import { ResourcesProvider } from './resources/resources.provider';
import { SyncService } from './storage/sync.service';
import { DataQueryService } from './common/data-query.service';
import { UsersService } from './resources/users.service';
import { LocationsService } from './resources/locations.service';
import { CategoriesService } from './resources/categories.service';
import { DevicesService } from './resources/devices.service';
import { EventsService } from './resources/events.service';
import { ScenesService } from './resources/scenes.service';
import { PairingsService } from './resources/pairings.service';
import { MediaService } from './resources/media.service';
import { WebSocketsService } from './websockets/websockets.service';
import { WizardsService } from './resources/wizards.service';
import { DatabaseService } from './storage/database.service';
import { AreasService } from './resources/areas.service';
import { PluginFactoryService } from './plugins/plugin-factory.service';
import { PluginUtilsService } from './plugins/plugin-utils.service';
import { ActionsService } from "./resources/actions.service";
import { EffectsService } from "./resources/effects.service";
import { ConditionsService } from "./resources/conditions.service";
import { DeviceReferenceService } from "./common/device-reference.service";
import { GatewayConnectivityService } from './common/gateway-connectivity.service';
import { AppConfiguration } from './common/app-configuration';
import { LocalConnectionService } from './common/local-connection.service';
import { HttpInterceptor } from "./common/http-interceptor.service";
export { APIClientService } from './common/api-client.service';
export { EventsManagerService } from './common/events-manager.service';
export { StorageService } from './storage/storage.service';
export { DatabaseService } from './storage/database.service';
export { WebSocketsService } from './websockets/websockets.service';
export { AuthService } from './auth/auth.service';
export { Oauth2Service } from './resources/oauth-2.service';
export { ResourcesProvider } from './resources/resources.provider';
export { SyncService } from './storage/sync.service';
export { DataQueryService } from './common/data-query.service';
export { UsersService } from './resources/users.service';
export { LocationsService } from './resources/locations.service';
export { CategoriesService } from './resources/categories.service';
export { DevicesService } from './resources/devices.service';
export { EventsService } from './resources/events.service';
export { ScenesService } from './resources/scenes.service';
export { PairingsService } from './resources/pairings.service';
export { RespondersService } from './resources/responders.service';
export { ControllersService } from './resources/controllers.service';
export { MediaService } from './resources/media.service';
export { WizardsService } from './resources/wizards.service';
export { AreasService } from './resources/areas.service';
export { ActionsService } from './resources/actions.service';
export { ConditionsService } from './resources/conditions.service';
export { DeviceReferenceService } from './common/device-reference.service';
export { EffectsService } from './resources/effects.service';
export { PluginFactoryService } from './plugins/plugin-factory.service';
export { PluginUtilsService } from './plugins/plugin-utils.service';
export { SmartenitPlugin } from './plugins/smartenit-plugin';
export { NaturalLanguageService } from './common/natural-language.service';
export { GatewayConnectivityService } from './common/gateway-connectivity.service';
export { LocalConnectionService } from './common/local-connection.service';
export { AppConfiguration } from './common/app-configuration';
export { HttpInterceptor } from "./common/http-interceptor.service";
// Models
export { ActionModel } from './models/action.model';
export { AreaModel } from './models/area.model';
export { CategoryModel } from './models/category.model';
export { ConditionModel } from './models/condition.model';
export { DeviceModel } from './models/device.model';
export { EffectModel } from './models/effect.model';
export { EventModel } from './models/event.model';
export { LocationModel } from './models/location.model';
export { SceneModel } from './models/scene.model';
export { PairingModel } from './models/pairing.model';
export { ResponderModel } from './models/responder.model';
export { ControllerModel } from './models/controller.model';
export { UserModel } from './models/user.model';
export { WizardModel } from './models/wizard.model';
// Plugins
export { DiscoverPlugin } from './plugins/discover/discover.plugin';
export { OnOffPlugin } from './plugins/on-off/on-off.plugin';
export { LevelControlServerPlugin } from './plugins/level-control-server/level-control-server.plugin';
export { SimpleMeteringServerPlugin } from './plugins/simple-metering-server/simple-metering-server.plugin';
export { ElectricalMeasurementServerPlugin } from './plugins/electrical-measurement-server/electrical-measurement-server.plugin';
export { BasicServerPlugin } from './plugins/basic-server/basic-server.plugin';
export { OnOffArrayServerPlugin } from './plugins/on-off-array-server/on-off-array-server.plugin';
export { ThermostatServerPlugin } from './plugins/thermostat-server/thermostat-server.plugin';
export { ThermostatModes } from './plugins/thermostat-server/thermostat-modes.enum';
export { DoorLockPlugin } from './plugins/door-lock-server/door-lock.plugin';
export { IASACEServerPlugin } from './plugins/iasace-server/iasace-server.plugin';
export { IASZoneServerPlugin } from './plugins/iaszone-server/iaszone-server.plugin';
export { IASACEPanelStatus } from './plugins/iasace-server/iasace-server-status.enum';
export { IASACEAlarmStatus } from './plugins/iasace-server/iasace-server-alarm.enum';
export { IASACEArmMode } from './plugins/iasace-server/iasace-server-arm-mode.enum';
// Interfaces
export var SmartenitModule = (function () {
    function SmartenitModule() {
    }
    SmartenitModule.withConfig = function (config) {
        AppConfiguration.initialConfig = config;
        return {
            ngModule: SmartenitModule
        };
    };
    SmartenitModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                LocalStorageModule.withConfig({
                    prefix: 'smartenit-app',
                    storageType: 'localStorage'
                })
            ],
            providers: [
                EventsManagerService,
                HttpInterceptor,
                AuthService,
                Oauth2Service,
                ResourcesProvider,
                WebSocketsService,
                AreasService,
                StorageService,
                DatabaseService,
                UsersService,
                LocationsService,
                CategoriesService,
                DevicesService,
                EventsService,
                ScenesService,
                PairingsService,
                MediaService,
                WizardsService,
                PluginFactoryService,
                PluginUtilsService,
                ActionsService,
                EffectsService,
                ConditionsService,
                DeviceReferenceService,
                LocalConnectionService,
                SyncService,
                DataQueryService,
                GatewayConnectivityService
            ]
        }), 
        __metadata('design:paramtypes', [])
    ], SmartenitModule);
    return SmartenitModule;
}());
//# sourceMappingURL=index.js.map