var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { Model } from "../common/model";
export var ConditionModel = (function (_super) {
    __extends(ConditionModel, _super);
    function ConditionModel(conditionsService, data) {
        _super.call(this, conditionsService, data);
        this.conditionsService = conditionsService;
    }
    Object.defineProperty(ConditionModel.prototype, "name", {
        get: function () {
            return this._name;
        },
        set: function (value) {
            this._name = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ConditionModel.prototype, "type", {
        get: function () {
            return this._data.type;
        },
        set: function (value) {
            this._data.type = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ConditionModel.prototype, "description", {
        get: function () {
            return this._data.description;
        },
        set: function (value) {
            this._data.description = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ConditionModel.prototype, "componentId", {
        get: function () {
            if (this.path) {
                var split = this.path.split('/');
                if (split && split.length > 4) {
                    return split[4];
                }
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ConditionModel.prototype, "processorName", {
        get: function () {
            if (this.path) {
                var split = this.path.split('/');
                if (split && split.length > 6) {
                    return split[6];
                }
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ConditionModel.prototype, "attribute", {
        get: function () {
            if (this.path) {
                var split = this.path.split('/');
                if (split && split.length > 8 && split[7] == 'attrs') {
                    return split[8];
                }
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ConditionModel.prototype, "parents", {
        get: function () {
            return this._data.parents;
        },
        set: function (value) {
            this._data.parents = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ConditionModel.prototype, "path", {
        get: function () {
            return this._data.path;
        },
        set: function (value) {
            this._data.path = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ConditionModel.prototype, "value", {
        get: function () {
            return this._data.value;
        },
        set: function (value) {
            this._data.value = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ConditionModel.prototype, "days", {
        get: function () {
            return this._data.days;
        },
        set: function (value) {
            this._data.days = value;
        },
        enumerable: true,
        configurable: true
    });
    ConditionModel.TIME_SUNSET = 'time-sunset';
    ConditionModel.TIME_SUNRISE = 'time-sunrise';
    ConditionModel.TIME_DEFAULT = 'time';
    ConditionModel.TIME_RANDOM = 'time-random';
    ConditionModel.TIME_WINDOW = 'time-window';
    ConditionModel.TIME_INTERVAL = 'time-interval';
    ConditionModel.DEVICE_STATE = 'device-state';
    ConditionModel.SUNRISE = 'sunrise';
    ConditionModel.SUNSET = 'sunset';
    ConditionModel.CRONTAB = '#crontab';
    ConditionModel.EQ = '#eq';
    return ConditionModel;
}(Model));
//# sourceMappingURL=condition.model.js.map