var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { Model } from "../common/model";
import { Subject } from "rxjs";
export var PairingModel = (function (_super) {
    __extends(PairingModel, _super);
    function PairingModel(pairingsService, data, webSocketsService) {
        var _this = this;
        _super.call(this, pairingsService, data);
        this.pairingsService = pairingsService;
        this.webSocketsService = webSocketsService;
        this._onPairingData = new Subject();
        this._onPairingStatus = new Subject();
        this._onPairingRemove = new Subject();
        this.webSocketsService.onPairingsMessage.subscribe(function (message) {
            if (message.resourceId == _this._id && message.data && message.data.response
                && message.data.response.value) {
                // This line always overrides pairing.state value
                _this._data.state = message.data.response.value;
                _this._onPairingData.next({ data: message.data.response.value });
                if (message.componentId && message.componentId === 'remove') {
                    message.data.response.value['pairId'] = _this._id;
                    _this._onPairingRemove.next({ data: message.data.response.value });
                }
                else {
                    _this._onPairingStatus.next({ data: message.data.response.value });
                }
            }
        });
    }
    PairingModel.prototype.retry = function () {
        this.pairingsService.post(this._id + '/retry').subscribe(function () { });
    };
    PairingModel.prototype.tryRemove = function () {
        return this.pairingsService.post(this._id + '/remove', { ownerId: this.ownerId });
    };
    Object.defineProperty(PairingModel.prototype, "target", {
        get: function () {
            return this._data.target;
        },
        set: function (value) {
            this._data.target = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PairingModel.prototype, "source", {
        get: function () {
            return this._data.source;
        },
        set: function (value) {
            this._data.source = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PairingModel.prototype, "pathId", {
        get: function () {
            return this._data.pathId;
        },
        set: function (value) {
            this._data.pathId = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PairingModel.prototype, "description", {
        get: function () {
            return this._data.description;
        },
        set: function (value) {
            this._data.description = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PairingModel.prototype, "state", {
        get: function () {
            return this._data.state;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PairingModel.prototype, "ownerId", {
        get: function () {
            return this._data.ownerId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PairingModel.prototype, "onPairData", {
        get: function () {
            return this._onPairingData.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PairingModel.prototype, "onPairStatus", {
        get: function () {
            return this._onPairingStatus.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PairingModel.prototype, "onPairRemove", {
        get: function () {
            return this._onPairingRemove.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    return PairingModel;
}(Model));
//# sourceMappingURL=pairing.model.js.map