var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { Model } from "../common/model";
import { Subject } from "rxjs";
export var SceneModel = (function (_super) {
    __extends(SceneModel, _super);
    function SceneModel(scenesService, data, webSocketsService) {
        var _this = this;
        _super.call(this, scenesService, data);
        this.scenesService = scenesService;
        this.webSocketsService = webSocketsService;
        this._onSceneData = new Subject();
        this.webSocketsService.onScenesMessage.subscribe(function (message) {
            if (message.resourceId == _this._id && message.data && message.data.response && message.data.response.value && message.data.response.value.enabled !== undefined) {
                _this._onSceneData.next({ enabled: message.data.response.value.enabled });
            }
        });
    }
    SceneModel.prototype.activate = function () {
        this.scenesService.post(this._id + '/activate').subscribe(function () { });
    };
    SceneModel.prototype.deactivate = function () {
        this.scenesService.post(this._id + '/deactivate').subscribe(function () { });
    };
    Object.defineProperty(SceneModel.prototype, "enabled", {
        get: function () {
            return this._data.enabled;
        },
        set: function (value) {
            this._data.enabled = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SceneModel.prototype, "onSceneData", {
        get: function () {
            return this._onSceneData.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    return SceneModel;
}(Model));
//# sourceMappingURL=scene.model.js.map