var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { SmartenitPlugin } from "../smartenit-plugin";
export var BasicServerPlugin = (function (_super) {
    __extends(BasicServerPlugin, _super);
    function BasicServerPlugin() {
        _super.apply(this, arguments);
    }
    Object.defineProperty(BasicServerPlugin.prototype, "stateTTL", {
        get: function () {
            return 3600;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BasicServerPlugin.prototype, "hardwareVersion", {
        get: function () {
            return this.state.firmwareVersion;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BasicServerPlugin.prototype, "softwareVersion", {
        get: function () {
            return this.state.applicationVersion + '-' + this.state.stackVersion;
        },
        enumerable: true,
        configurable: true
    });
    BasicServerPlugin.prototype.getHardwareVersion = function () {
        this.getAttributeWithSubscribeOption(this.componentId, this.processorName, 'HWVersion', null, false);
    };
    BasicServerPlugin.prototype.getSoftwareVersion = function () {
        this.getAttributeWithSubscribeOption(this.componentId, this.processorName, 'ApplicationVersion', null, false);
        this.getAttributeWithSubscribeOption(this.componentId, this.processorName, 'StackVersion', null, false);
    };
    BasicServerPlugin.prototype.getStatusPayload = function () {
        return ['HWVersion', 'ApplicationVersion', 'StackVersion'];
    };
    BasicServerPlugin.prototype.processMessage = function (message) {
        var response = message && message.data && message.data.response;
        var attribute = message && message.attributeOrMethod;
        if (attribute === 'HWVersion') {
            this.state.hardwareVersion = response.value || '-';
            this._onUpdate.next({ state: this.state });
        }
        else if (attribute === 'ApplicationVersion') {
            this.state.applicationVersion = response.value || '-';
            this._onUpdate.next({ state: this.state });
        }
        else if (attribute === 'StackVersion') {
            this.state.stackVersion = response.value || '-';
            this._onUpdate.next({ state: this.state });
        }
        return this.state;
    };
    return BasicServerPlugin;
}(SmartenitPlugin));
//# sourceMappingURL=basic-server.plugin.js.map