var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { SmartenitPlugin } from "../smartenit-plugin";
export var DiscoverPlugin = (function (_super) {
    __extends(DiscoverPlugin, _super);
    function DiscoverPlugin() {
        _super.apply(this, arguments);
    }
    DiscoverPlugin.prototype.onInit = function () {
        if (this.state != null &&
            this.state.discovering &&
            this.state.hasOwnProperty('discoverTime') &&
            this.state.hasOwnProperty('iteration')) {
            this.startInterval(this.state.discoverTime, this.state.iteration);
        }
    };
    DiscoverPlugin.prototype.startDiscovery = function (discoverTime) {
        if (discoverTime === void 0) { discoverTime = 254; }
        this.reset();
        var payload = { duration: discoverTime };
        this.discovering = true;
        this.startInterval(discoverTime);
        this.executeMethod(this.componentId, this.processorName, 'discover', payload);
    };
    DiscoverPlugin.prototype.startInterval = function (discoverTime, currentIteration) {
        var _this = this;
        clearInterval(this.interval);
        if (currentIteration !== undefined) {
            if (currentIteration >= discoverTime) {
                this.reset();
                return;
            }
            this.iteration = currentIteration;
        }
        this.discoverTime = discoverTime;
        this.interval = setInterval(function () {
            _this.progress = Math.floor(_this.iteration++ / _this.discoverTime * 100);
            _this.saveState({
                progress: _this.progress,
                discovering: _this.discovering,
                discoverTime: _this.discoverTime,
                iteration: _this.iteration
            }, _this.discoverTime - _this.iteration);
            _this._onUpdate.next({ progress: _this.progress });
            if (_this.iteration >= _this.discoverTime) {
                clearInterval(_this.interval);
                _this.reset();
            }
        }, 1000);
    };
    DiscoverPlugin.prototype.getProgress = function () {
        return this.progress;
    };
    DiscoverPlugin.prototype.stopDiscovery = function () {
        this.reset();
        var payload = { duration: 0 };
        this.executeMethod(this.componentId, this.processorName, 'discover', payload);
    };
    DiscoverPlugin.prototype.processMessage = function (message) {
        return this.state;
    };
    DiscoverPlugin.prototype.reset = function () {
        this.iteration = 1;
        this.progress = 0;
        clearInterval(this.interval);
        this.discovering = false;
        this.saveState({ progress: this.progress, discovering: this.discovering, iteration: this.iteration });
    };
    return DiscoverPlugin;
}(SmartenitPlugin));
//# sourceMappingURL=discover.plugin.js.map