var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { SmartenitPlugin } from "../smartenit-plugin";
import { Observable } from "rxjs";
var CACHE_TIME = 12 * 60 * 60;
export var DoorLockPlugin = (function (_super) {
    __extends(DoorLockPlugin, _super);
    function DoorLockPlugin() {
        _super.apply(this, arguments);
        this._lastUpdate = 0;
    }
    DoorLockPlugin.prototype.lock = function () {
        return this.executeMethod(this.componentId, this.processorName, 'LockDoor', { Code: "" });
    };
    DoorLockPlugin.prototype.unlock = function () {
        return this.executeMethod(this.componentId, this.processorName, 'UnlockDoor', { Code: "" });
    };
    DoorLockPlugin.prototype.getLastUpdateTimestamp = function () {
        return this._lastUpdate;
    };
    DoorLockPlugin.prototype.isLocked = function () {
        return this.state === true;
    };
    DoorLockPlugin.prototype.isUnlocked = function () {
        return this.state === false;
    };
    DoorLockPlugin.prototype.getEffectOptions = function () {
        return [{
                name: 'Lock',
                value: {
                    method: 'LockDoor'
                }
            },
            {
                name: 'Unlock',
                value: {
                    method: 'UnlockDoor'
                }
            }];
    };
    DoorLockPlugin.prototype.getEffectAttribute = function () {
        return null;
    };
    DoorLockPlugin.prototype.getEffectMethod = function (context) {
        return null;
    };
    DoorLockPlugin.prototype.getConditionOptions = function () {
        return [{
                name: 'Is Locked',
                value: 1
            },
            {
                name: 'Is Unlocked',
                value: 2
            }];
    };
    DoorLockPlugin.prototype.getCachedValues = function (subscribe) {
        var _this = this;
        var cacheValues = [
            this.getCache('lastUpdate'),
            this.getCache()
        ];
        var observable = Observable.forkJoin(cacheValues).flatMap(function (array) {
            if (array && array[0] != null) {
                _this._lastUpdate = array[0];
            }
            if (array && array[1] != null) {
                _this.state = array[1];
            }
            if (_this.state != null) {
                _this.device.cached = true;
            }
            _this._onUpdate.next({
                lastUpdate: _this._lastUpdate,
                state: _this.state
            });
            return Observable.of(_this.state);
        });
        if (subscribe === true) {
            return observable;
        }
        var subscription = observable.subscribe(function () { return subscription.unsubscribe(); });
    };
    DoorLockPlugin.prototype.getConditionAttribute = function () {
        return 'LockState';
    };
    DoorLockPlugin.prototype.getStatusPayload = function () {
        return ['LockState'];
    };
    DoorLockPlugin.prototype.processMessage = function (message) {
        var attribute = message && message.attributeOrMethod;
        if (attribute === 'state' || attribute === 'LockState') {
            var response = message && message.data && message.data.response;
            this.state = parseInt(response.value) === 1;
            this._lastUpdate = parseInt(response.timestamp);
            this.setCache('lastUpdate', this._lastUpdate, CACHE_TIME);
            this._onUpdate.next({ state: this.state, lastUpdate: this._lastUpdate });
        }
        return this.state;
    };
    return DoorLockPlugin;
}(SmartenitPlugin));
//# sourceMappingURL=door-lock.plugin.js.map