var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { SmartenitPlugin } from "../smartenit-plugin";
import { Observable } from "rxjs";
export var ElectricalMeasurementServerPlugin = (function (_super) {
    __extends(ElectricalMeasurementServerPlugin, _super);
    function ElectricalMeasurementServerPlugin() {
        _super.apply(this, arguments);
    }
    ElectricalMeasurementServerPlugin.prototype.getUnit = function (attribute) {
        return 'W';
    };
    ElectricalMeasurementServerPlugin.prototype.getActivePower = function () {
        return this.state.activePower;
    };
    ElectricalMeasurementServerPlugin.prototype.getValue = function (attribute) {
        return Number(this.getActivePower());
    };
    ElectricalMeasurementServerPlugin.prototype.getConditionAttribute = function () {
        return 'ActivePower';
    };
    ElectricalMeasurementServerPlugin.prototype.getEffectAttribute = function () {
        return null;
    };
    ElectricalMeasurementServerPlugin.prototype.getEffectMethod = function (context) {
        return null;
    };
    ElectricalMeasurementServerPlugin.prototype.setValue = function (value, attribute, subscribe) {
        // Do nothing becase values are read only
        if (subscribe) {
            return Observable.of(true);
        }
        return true;
    };
    ElectricalMeasurementServerPlugin.prototype.getTextValue = function (context) {
        return this.getActivePower() + this.getUnit();
    };
    ElectricalMeasurementServerPlugin.prototype.getStatusPayload = function () {
        return ['ActivePower'];
    };
    ElectricalMeasurementServerPlugin.prototype.processMessage = function (message) {
        var response = message && message.data && message.data.response;
        var attribute = message && message.attributeOrMethod;
        if (attribute === 'ActivePower') {
            this.state.activePower = response.value;
            this._onUpdate.next({ state: this.state });
        }
        return this.state;
    };
    return ElectricalMeasurementServerPlugin;
}(SmartenitPlugin));
//# sourceMappingURL=electrical-measurement-server.plugin.js.map