import { SmartenitPlugin } from '../smartenit-plugin';
import { IIASACEServer } from '../../interfaces/iasace.interface';
import { IWebSocketDeviceMessage } from '../../websockets/websocket-device-message.interface';
export declare class IASACEServerPlugin extends SmartenitPlugin implements IIASACEServer {
    onInit(): void;
    _armResponse: any;
    _alarmStatus: any;
    _bypassedZoneList: any;
    _zones: any;
    setEmergency(type: string): void;
    arm(mode: number): void;
    disarm(): void;
    getZoneInformation(zoneId: number): void;
    /**
     * Bypass command
     * @param ZoneIDArray Contains the id of the index of each Zone
     *  in the CIE's zone table eg. [1,3,3,4]
     * @param ArmDisarmCode Should be between four and eight
     *  alphanumeric characters in length.
     */
    bypass(ZoneIDArray?: any[], ArmDisarmCode?: string): void;
    bypassZone(zoneId: number, armDisarmCode?: string): void;
    getZones(): any;
    getBypassedZoneList(): void;
    getEffectOptions(): any;
    getEffectAttribute(): string;
    getEffectMethod(context?: any): string;
    getConditionOptions(): any;
    getConditionAttribute(): string;
    getCachedValues(subscribe?: boolean): any;
    processMessage(message: IWebSocketDeviceMessage): any;
    getStatusPayload(): any;
    getStatus(context?: string, force?: boolean, asObservable?: boolean, payload?: any): void;
    arraysOfNumbersAreEqual(array1?: any[], array2?: any[]): boolean;
    parseZoneMap(response: any): void;
    updateZonesBypassed(bypassList: any): void;
}
