var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { SmartenitPlugin } from "../smartenit-plugin";
import { OnOffPlugin } from '../on-off/on-off.plugin';
var CURRENT_LEVEL_MIN = 0;
var CURRENT_LEVEL_MAX = 254;
export var LevelControlServerPlugin = (function (_super) {
    __extends(LevelControlServerPlugin, _super);
    function LevelControlServerPlugin() {
        _super.apply(this, arguments);
    }
    LevelControlServerPlugin.prototype.setValue = function (value, attribute) {
        var _this = this;
        value = Math.round(value * 2.55);
        var payload = {
            Level: value,
            TransitionTime: 0
        };
        setTimeout(function () {
            _this.readDeviceOnOffStatus();
        }, 500);
        return this.executeMethod(this.componentId, this.processorName, 'MoveToLevelWOnOff', payload);
    };
    LevelControlServerPlugin.prototype.getUnit = function (attribute) {
        return '%';
    };
    LevelControlServerPlugin.prototype.getValue = function (attribute) {
        return this.state;
    };
    LevelControlServerPlugin.prototype.getConditionAttribute = function () {
        return 'CurrentLevel';
    };
    LevelControlServerPlugin.prototype.getEffectAttribute = function () {
        return null;
    };
    LevelControlServerPlugin.prototype.getEffectMethod = function (context) {
        return 'MoveToLevelWOnOff';
    };
    LevelControlServerPlugin.prototype.getEffectPayload = function (value, attribute, method) {
        return { Level: this.getRawValue(value, attribute, method), TransitionTime: 0 };
    };
    LevelControlServerPlugin.prototype.valueFromEffectPayload = function (payload, attribute, method) {
        var value = payload && payload['Level'] ? payload['Level'] : 50;
        return this.getProcessedValue(value, attribute, method);
    };
    LevelControlServerPlugin.prototype.getResponderAttribute = function () {
        return 'CurrentLevel';
    };
    LevelControlServerPlugin.prototype.getResponderMethod = function () {
        return null;
    };
    LevelControlServerPlugin.prototype.getStatusPayload = function () {
        return ['CurrentLevel'];
    };
    LevelControlServerPlugin.prototype.processMessage = function (message) {
        var attribute = message && message.attributeOrMethod;
        if (attribute === 'CurrentLevel') {
            var response = message && message.data && message.data.response;
            var value = Number(response.value);
            this.state = value / 2.55;
            this._onUpdate.next({ state: this.state });
        }
        return this.state;
    };
    LevelControlServerPlugin.prototype.readDeviceOnOffStatus = function () {
        var _this = this;
        Object.keys(this.device.plugins)
            .map(function (key) { return _this.device.plugins[key]; })
            .filter(function (plugin) { return plugin instanceof OnOffPlugin; })
            .forEach(function (plugin) {
            plugin.device.getStatus(plugin.componentId, plugin.processorName, plugin.getStatusPayload(), 'cached=false');
        });
    };
    LevelControlServerPlugin.prototype.getRawValue = function (value, attribute, method) {
        if (!attribute || attribute === 'CurrentLevel') {
            return this.pluginUtilsService.getValueFromPercentage(value, CURRENT_LEVEL_MIN, CURRENT_LEVEL_MAX);
        }
        else {
            return value;
        }
    };
    LevelControlServerPlugin.prototype.getProcessedValue = function (value, attribute, method) {
        if ((method && method.toLowerCase() === 'movetolevelwonoff') || !attribute || attribute === 'CurrentLevel') {
            return this.pluginUtilsService.getValueToPercentage(value, CURRENT_LEVEL_MIN, CURRENT_LEVEL_MAX);
        }
        else {
            return value;
        }
    };
    return LevelControlServerPlugin;
}(SmartenitPlugin));
//# sourceMappingURL=level-control-server.plugin.js.map