var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { SmartenitPlugin } from "../smartenit-plugin";
export var NotificationServerPlugin = (function (_super) {
    __extends(NotificationServerPlugin, _super);
    function NotificationServerPlugin() {
        _super.apply(this, arguments);
    }
    NotificationServerPlugin.prototype.sendEmail = function (emails, subject, message) {
        return this.executeMethod(this.componentId, this.processorName, 'SendEmail', {
            To: emails,
            Subject: subject,
            Text: message
        });
    };
    NotificationServerPlugin.prototype.getEffectMethod = function (context) {
        return 'SendEmail';
    };
    NotificationServerPlugin.prototype.getEffectAttribute = function () {
        return null;
    };
    NotificationServerPlugin.prototype.getResponderAttribute = function () {
        return null;
    };
    NotificationServerPlugin.prototype.getResponderMethod = function () {
        return 'SendEmail';
    };
    NotificationServerPlugin.prototype.getStatus = function () {
        // void
    };
    NotificationServerPlugin.prototype.processMessage = function (message) {
        // void
        return this.state;
    };
    NotificationServerPlugin.prototype.getProcessedValue = function (value, attribute, method) {
        if (!method) {
            return value;
        }
        var data = {
            To: {
                users: [],
                emails: []
            },
            Subject: value['Subject'],
            Text: value['Text']
        };
        if (method == "SendEmail") {
            data.To.emails = value.To.split(",");
        }
        if (method == "SendPushNotification") {
            data.To.users = value.To;
        }
        return data;
    };
    return NotificationServerPlugin;
}(SmartenitPlugin));
//# sourceMappingURL=notification-server.plugin.js.map