import { SmartenitPlugin } from "../smartenit-plugin";
import { IWebSocketDeviceMessage } from "../../websockets/websocket-device-message.interface";
import { Observable, Subject } from "rxjs";
export declare class OnOffArrayServerPlugin extends SmartenitPlugin {
    private _zones;
    private _programs;
    private _percentAdjust;
    private _isEnabled;
    private _zonesLen;
    private days;
    readonly isEnabled: boolean;
    readonly currentRunningProgram: any;
    readonly percentAdjust: number;
    readonly zones: any;
    readonly programs: any;
    readonly zonesLen: any;
    protected _onRainDelayChange: Subject<boolean>;
    readonly onRainDelayChange: Observable<boolean>;
    onInit(): void;
    getZoneName(zoneIdx: number): void;
    setZoneName(zoneIndex: number, zoneName: string): void;
    readMode(delay?: boolean): void;
    private getCacheValuesWithDefaults(useDefaultValues?);
    getState(cachedState?: boolean, delay?: boolean): void;
    getArraySize(): void;
    setArraySize(arraySize: any): void;
    updateArraySize(arraySize: any): void;
    getZoneNames(): void;
    turnOnProgram(programIndex: number): void;
    turnOffProgram(programIndex: number): void;
    toggleProgram(programIndex: number): void;
    toggleZone(zoneIndex: number): void;
    getProgramTimers(programIndex: number): void;
    getCurrentRunningTimer(): void;
    setProgramTimers(programIndex: number, timerValues: any): void;
    toggleDeviceEnable(): void;
    disableDevice(): Observable<boolean>;
    enableDevice(): Observable<boolean>;
    private inhibitOn(mode);
    private inhibitOff(mode);
    private setProgramInMode(programIndex);
    private setProgramId(mode, programIndex);
    private getProgramIdFromMode(mode);
    private getDeviceisEnabled(mode);
    private getPercentAdjust(mode);
    processZonesResponse(bitmask: any, zones: any): any;
    processMessage(message: IWebSocketDeviceMessage): any;
    getNearestCondition(): Observable<any>;
    getCrontabFromValue(value: any): any;
    private nearestConditionDescriptionHelper(conditions);
    createProgramAction(programName: string, programId: string, startTimes: any, crontab: any, actionId?: any, effectId?: any): Observable<any>;
    getRainDelayAction(): Observable<any>;
    stopRainDelay(): Observable<any>;
    startRainDelay(delay: any): Observable<any>;
    processDeviceMessage(message: IWebSocketDeviceMessage): any;
    getProgramConditions(): Observable<any>;
    setPercentAdjust(percent: number): void;
    getProgramAutomation(programId: number): Observable<any>;
    getEffectLabelOptions(context: any): any;
    getEffectValueOptions(context: any): any;
    getEffectCurrentLabel(context: any, attributeOrMethod: string): any;
    getEffectCurrentValue(context: any, attributeOrMethod: string): string;
    getEffectMethod(context?: any): string;
}
