var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { SmartenitPlugin } from "../smartenit-plugin";
import { Observable, Subject } from "rxjs";
import { ConditionModel } from "../../models/condition.model";
var INIT_ZONES_LEN = 8;
var INIT_ZONES = [
    { name: 'Zone 1', isOn: false, enabled: true, index: 0, currentTime: 0 },
    { name: 'Zone 2', isOn: false, enabled: true, index: 1, currentTime: 0 },
    { name: 'Zone 3', isOn: false, enabled: true, index: 2, currentTime: 0 },
    { name: 'Zone 4', isOn: false, enabled: true, index: 3, currentTime: 0 },
    { name: 'Zone 5', isOn: false, enabled: true, index: 4, currentTime: 0 },
    { name: 'Zone 6', isOn: false, enabled: true, index: 5, currentTime: 0 },
    { name: 'Zone 7', isOn: false, enabled: true, index: 6, currentTime: 0 },
    { name: 'Zone 8', isOn: false, enabled: true, index: 7, currentTime: 0 },
    { name: 'Zone 9', isOn: false, enabled: true, index: 8, currentTime: 0 },
    { name: 'Zone 10', isOn: false, enabled: true, index: 9, currentTime: 0 },
    { name: 'Zone 11', isOn: false, enabled: true, index: 10, currentTime: 0 },
    { name: 'Zone 12', isOn: false, enabled: true, index: 11, currentTime: 0 },
    { name: 'Zone 13', isOn: false, enabled: true, index: 12, currentTime: 0 },
    { name: 'Zone 14', isOn: false, enabled: true, index: 13, currentTime: 0 },
    { name: 'Zone 15', isOn: false, enabled: true, index: 14, currentTime: 0 },
    { name: 'Zone 16', isOn: false, enabled: true, index: 15, currentTime: 0 }
];
var INIT_PROGRAMS = [
    { name: 'Default', isOn: false, timers: [], index: 0 },
    { name: 'Program A', isOn: false, timers: [], index: 1 },
    { name: 'Program B', isOn: false, timers: [], index: 2 },
    { name: 'Program C', isOn: false, timers: [], index: 3 },
    { name: 'Program D', isOn: false, timers: [], index: 4 }
];
var INIT_PERCENT_ADJUST = 0;
var INIT_IS_ENABLED = false;
var CACHE_TIME = 3600;
export var OnOffArrayServerPlugin = (function (_super) {
    __extends(OnOffArrayServerPlugin, _super);
    function OnOffArrayServerPlugin() {
        _super.apply(this, arguments);
        this._zones = INIT_ZONES;
        this._programs = INIT_PROGRAMS;
        this._percentAdjust = INIT_PERCENT_ADJUST;
        this._isEnabled = INIT_IS_ENABLED;
        this._zonesLen = INIT_ZONES_LEN;
        this.days = [
            { value: 1, name: 'Monday', shortName: 'Mon', enabled: false },
            { value: 2, name: 'Tuesday', shortName: 'Tue', enabled: false },
            { value: 3, name: 'Wednesday', shortName: 'Wed', enabled: false },
            { value: 4, name: 'Thursday', shortName: 'Thu', enabled: false },
            { value: 5, name: 'Friday', shortName: 'Fri', enabled: false },
            { value: 6, name: 'Saturday', shortName: 'Sat', enabled: false },
            { value: 0, name: 'Sunday', shortName: 'Sun', enabled: false }
        ];
        this._onRainDelayChange = new Subject();
    }
    Object.defineProperty(OnOffArrayServerPlugin.prototype, "isEnabled", {
        get: function () {
            return this._isEnabled;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OnOffArrayServerPlugin.prototype, "currentRunningProgram", {
        get: function () {
            return this._programs.find(function (item, index) {
                return item.isOn === true;
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OnOffArrayServerPlugin.prototype, "percentAdjust", {
        get: function () {
            return this._percentAdjust;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OnOffArrayServerPlugin.prototype, "zones", {
        get: function () {
            return this._zones;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OnOffArrayServerPlugin.prototype, "programs", {
        get: function () {
            return this._programs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OnOffArrayServerPlugin.prototype, "zonesLen", {
        get: function () {
            return this._zonesLen;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OnOffArrayServerPlugin.prototype, "onRainDelayChange", {
        get: function () {
            return this._onRainDelayChange.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    OnOffArrayServerPlugin.prototype.onInit = function () {
        this.getCacheValuesWithDefaults(true);
    };
    OnOffArrayServerPlugin.prototype.getZoneName = function (zoneIdx) {
        this.device.executeMethod(this.componentId, this.processorName, 'GetName', { ZoneID: zoneIdx + 1 });
    };
    OnOffArrayServerPlugin.prototype.setZoneName = function (zoneIndex, zoneName) {
        this.device.executeMethod(this.componentId, this.processorName, 'SetName', {
            ZoneID: zoneIndex + 1,
            ZoneName: zoneName
        });
        if (this.device && (this.device.meta === undefined || this.device.meta === null)) {
            this.device.meta = {};
        }
        this.device.meta.zoneNames = this.zones.map(function (zone) {
            return (zoneIndex === zone.index) ? zoneName : zone.name;
        });
        this.device.save().subscribe();
        this.getZoneName(zoneIndex);
    };
    OnOffArrayServerPlugin.prototype.readMode = function (delay) {
        var _this = this;
        if (delay === void 0) { delay = false; }
        if (delay === true) {
            setTimeout(function () {
                _this.device.getAttribute(_this.componentId, _this.processorName, 'Mode')
                    .subscribe(function () {
                });
            }, 500);
        }
        else {
            this.device.getAttribute(this.componentId, this.processorName, 'Mode')
                .subscribe(function () {
            });
        }
    };
    OnOffArrayServerPlugin.prototype.getCacheValuesWithDefaults = function (useDefaultValues) {
        var _this = this;
        if (useDefaultValues === void 0) { useDefaultValues = false; }
        var cacheValues = [
            this.getCache('zones'),
            this.getCache('percentAdjust'),
            this.getCache('programs'),
            this.getCache('isEnabled'),
            this.getCache('zonesLen'),
            this.getCache()
        ];
        Observable.forkJoin(cacheValues).subscribe(function (array) {
            if (array && array[0] != null) {
                _this._zones = array[0];
            }
            else if (useDefaultValues) {
                _this._zones = INIT_ZONES;
            }
            if (array && array[1] != null) {
                _this._percentAdjust = array[1];
            }
            else if (useDefaultValues) {
                _this._percentAdjust = INIT_PERCENT_ADJUST;
            }
            if (array && array[2] != null) {
                _this._programs = array[2];
            }
            else if (useDefaultValues) {
                _this._programs = INIT_PROGRAMS;
            }
            if (array && array[3] != null) {
                _this._isEnabled = array[3];
            }
            else if (useDefaultValues) {
                _this._isEnabled = INIT_IS_ENABLED;
            }
            if (array && array[4] != null) {
                _this._zonesLen = array[4];
            }
            else if (useDefaultValues) {
                _this._zonesLen = INIT_ZONES_LEN;
            }
            if (array && array[5] != null) {
                _this.state = array[5];
            }
            else if (useDefaultValues) {
                _this.state = {};
            }
            _this._onUpdate.next({
                zones: _this.zones,
                programs: _this.programs,
                state: _this.state,
                isEnabled: _this.isEnabled,
                percentAdjust: _this.percentAdjust
            });
        });
    };
    OnOffArrayServerPlugin.prototype.getState = function (cachedState, delay) {
        var _this = this;
        if (cachedState === void 0) { cachedState = false; }
        if (delay === void 0) { delay = false; }
        if (cachedState) {
            this.getCacheValuesWithDefaults();
        }
        if (delay === true) {
            setTimeout(function () {
                _this.device.getAttribute(_this.componentId, _this.processorName, 'State').subscribe();
                _this.getArraySize();
            }, 500);
        }
        else {
            this.device.getAttribute(this.componentId, this.processorName, 'State').subscribe();
            this.getArraySize();
        }
    };
    OnOffArrayServerPlugin.prototype.getArraySize = function () {
        var _this = this;
        if (this.device && this.device.meta && this.device.meta.arraySize) {
            this.updateArraySize(this.device.meta.arraySize);
        }
        else {
            this.device.getAttribute(this.componentId, this.processorName, 'ArraySize').subscribe(function (response) {
                if (response && response.apiCache && response.data && response.data.length && response.data[0].v) {
                    var value = response.data[0].v.value;
                    _this.updateArraySize(value);
                    _this.setArraySize(value);
                }
            });
        }
    };
    OnOffArrayServerPlugin.prototype.setArraySize = function (arraySize) {
        if (!this.device || !this.device.meta || !this.device.meta.arraySize) {
            if (this.device && (this.device.meta === undefined || this.device.meta === null)) {
                this.device.meta = {};
            }
            this.device.meta.arraySize = arraySize;
            this.device.save().subscribe();
        }
    };
    OnOffArrayServerPlugin.prototype.updateArraySize = function (arraySize) {
        this._zonesLen = arraySize;
        this.setCache('zonesLen', this._zonesLen, CACHE_TIME);
        this._onUpdate.next({ zonesLen: this._zonesLen });
    };
    OnOffArrayServerPlugin.prototype.getZoneNames = function () {
        var _this = this;
        if (this.device && this.device.meta && this.device.meta.zoneNames) {
            this._zones = this._zones.map(function (zone) {
                return Object.assign({}, zone, {
                    name: _this.device.meta.zoneNames[zone.index] || zone.name
                });
            });
            this._onUpdate.next({ zones: this.zones });
        }
        else {
            this._zones.forEach(function (zone, idx) {
                _this.getZoneName(idx);
            });
        }
    };
    OnOffArrayServerPlugin.prototype.turnOnProgram = function (programIndex) {
        var program = this.programs[programIndex] || {};
        this._programs = this._programs.map(function (item, index) {
            item.isOn = false;
            return item;
        });
        if (this._programs[programIndex]) {
            this._programs[programIndex].isOn = true;
        }
        this._onUpdate.next({ programs: this.programs });
        var method = 'ProgramOn';
        var payload = { ProgramID: programIndex };
        this.device.executeMethod(this.componentId, this.processorName, method, payload, false);
        this.readMode(true);
        this.getState();
    };
    OnOffArrayServerPlugin.prototype.turnOffProgram = function (programIndex) {
        var program = this.programs[programIndex] || {};
        this._programs = this._programs.map(function (item, index) {
            item.isOn = false;
            return item;
        });
        if (this._programs[programIndex]) {
            this._programs[programIndex].isOn = true;
        }
        this._onUpdate.next({ programs: this.programs });
        var method = 'ProgramOff';
        var payload = { ProgramID: programIndex };
        this.device.executeMethod(this.componentId, this.processorName, method, payload, false);
        this.readMode(true);
        this.getState();
    };
    OnOffArrayServerPlugin.prototype.toggleProgram = function (programIndex) {
        var program = this.programs[programIndex] || {};
        this._programs = this._programs.map(function (item, index) {
            if (index - programIndex) {
                item.isOn = false;
            }
            return item;
        });
        if (this._programs[programIndex]) {
            this._programs[programIndex].isOn = !this._programs[programIndex].isOn;
        }
        this._onUpdate.next({ programs: this.programs });
        var method = program.isOn ? 'ProgramOn' : 'ProgramOff';
        var payload = { ProgramID: programIndex };
        this.device.executeMethod(this.componentId, this.processorName, method, payload, false);
        if (method === 'ProgramOn') {
            this.getCurrentRunningTimer();
        }
        else {
            this._programs = this._programs.map(function (item, index) {
                item.isOn = false;
                return item;
            });
            this._zones = this._zones.map(function (item, index) {
                item.isOn = false;
                return item;
            });
        }
    };
    OnOffArrayServerPlugin.prototype.toggleZone = function (zoneIndex) {
        var zone = this._zones[zoneIndex] || {};
        if (this._zones[zoneIndex]) {
            this._zones[zoneIndex].isOn = !this._zones[zoneIndex].isOn;
        }
        var method = zone.isOn ? 'On' : 'Off';
        var payload = { ZoneID: zoneIndex + 1 };
        this.device.executeMethod(this.componentId, this.processorName, method, payload, false);
        if (method === 'On') {
            this.getCurrentRunningTimer();
        }
        else {
            this._programs = this._programs.map(function (item, index) {
                item.isOn = false;
                return item;
            });
            this._zones = this._zones.map(function (item, index) {
                item.isOn = false;
                return item;
            });
        }
    };
    OnOffArrayServerPlugin.prototype.getProgramTimers = function (programIndex) {
        var method = 'GetTimers';
        var payload = { TimerBankID: programIndex };
        // this.setProgramInMode(programIndex).subscribe(() => {
        this.device.executeMethod(this.componentId, this.processorName, method, payload, false);
        this.getState();
        // });
    };
    OnOffArrayServerPlugin.prototype.getCurrentRunningTimer = function () {
        var method = 'GetTimers';
        var payload = { TimerBankID: 5 };
        this.device.executeMethod(this.componentId, this.processorName, method, payload);
    };
    OnOffArrayServerPlugin.prototype.setProgramTimers = function (programIndex, timerValues) {
        var programName = this._programs[programIndex].name;
        var method = 'SetTimers';
        var timerValuesSecs = timerValues.map(function (timer) {
            return parseInt(timer) * 60;
        });
        var payload = {
            TimerBankID: programIndex,
            ArrayOfTimerValues: timerValuesSecs
        };
        this.device.executeMethod(this.componentId, this.processorName, method, payload, false);
        this.getProgramTimers(programIndex);
    };
    OnOffArrayServerPlugin.prototype.toggleDeviceEnable = function () {
        if (this._isEnabled) {
            this.disableDevice();
        }
        else {
            this.enableDevice();
        }
    };
    OnOffArrayServerPlugin.prototype.disableDevice = function () {
        var _this = this;
        if (this.state.mode === undefined) {
            this._onUpdate.next({ isEnabled: false });
            return Observable.of(false);
        }
        var newMode = this.inhibitOn(this.state.mode);
        var params = { value: newMode };
        this.device.setAttribute(this.componentId, this.processorName, 'Mode', params).subscribe(function () {
            _this.readMode(true);
        });
    };
    OnOffArrayServerPlugin.prototype.enableDevice = function () {
        var _this = this;
        if (this.state.mode === undefined) {
            this._onUpdate.next({ isEnabled: false });
            return Observable.of(false);
        }
        var newMode = this.inhibitOff(this.state.mode);
        var params = { value: newMode };
        this.device.setAttribute(this.componentId, this.processorName, 'Mode', params).subscribe(function () {
            _this.readMode(true);
        });
    };
    OnOffArrayServerPlugin.prototype.inhibitOn = function (mode) {
        var ihibitMask = 1 << 8;
        return mode | ihibitMask;
    };
    OnOffArrayServerPlugin.prototype.inhibitOff = function (mode) {
        var ihibitMask = 1 << 8;
        return mode & ~ihibitMask;
    };
    OnOffArrayServerPlugin.prototype.setProgramInMode = function (programIndex) {
        if (this.state.mode === undefined) {
            return Observable.of(true);
        }
        var newMode = this.setProgramId(this.state.mode, programIndex);
        var params = { value: newMode };
        return this.device.setAttribute(this.componentId, this.processorName, 'Mode', params);
    };
    OnOffArrayServerPlugin.prototype.setProgramId = function (mode, programIndex) {
        var timerMask = 287;
        var shiftLeft = programIndex << 5;
        var cleanedMode = mode & timerMask;
        var newMode = cleanedMode | shiftLeft;
        return newMode;
    };
    OnOffArrayServerPlugin.prototype.getProgramIdFromMode = function (mode) {
        var shiftRight = mode >> 5;
        return shiftRight & 7;
    };
    OnOffArrayServerPlugin.prototype.getDeviceisEnabled = function (mode) {
        return mode & 256 ? true : false;
    };
    OnOffArrayServerPlugin.prototype.getPercentAdjust = function (mode) {
        return (mode & 31) * 10;
    };
    OnOffArrayServerPlugin.prototype.processZonesResponse = function (bitmask, zones) {
        return zones.map(function (zone, idx) {
            var shiftRight = 1 << idx;
            if (bitmask & shiftRight) {
                zone.isOn = true;
            }
            else {
                zone.isOn = false;
            }
            return zone;
        });
    };
    OnOffArrayServerPlugin.prototype.processMessage = function (message) {
        var attribute = message && message.attributeOrMethod;
        var response = message && message.data && message.data.response;
        if (attribute.toLowerCase() === 'state') {
            var bitmask = response.value;
            this._zones = this.processZonesResponse(bitmask, this.zones);
            this.setCache('zones', this._zones, CACHE_TIME);
            this._onUpdate.next({ zones: this.zones });
        }
        else if (attribute === 'GetNameResponse') {
            var zoneID = response.value.ZoneID;
            var zoneIndex = zoneID - 1;
            var zoneName = response.value.ZoneName;
            if (zoneName == null) {
                if (this.device && this.device.meta && this.device.meta.zoneNames && this.device.meta.zoneNames[zoneIndex]) {
                    this._zones[zoneIndex].name = this.device.meta.zoneNames[zoneIndex];
                }
                else {
                    this._zones[zoneIndex].name = 'Zone ' + zoneID;
                }
            }
            else {
                this._zones[zoneIndex].name = zoneName;
            }
            this.setCache('zones', this._zones, CACHE_TIME);
            this._onUpdate.next({ zones: this.zones });
        }
        else if (attribute == 'GetTimersResponse') {
            var programId = response.value.TimerBankID;
            if (programId != 5) {
                var timersInSecs = response.value.ArrayOfTimerValues;
                var timersInMins = timersInSecs && timersInSecs.map(function (timer) {
                    return Math.round(timer / 60);
                });
                this._programs[programId].timers = Array.isArray(timersInSecs) && timersInSecs.length > 0 ?
                    timersInMins :
                    this._programs[programId].timers;
                this.setCache('programs', this._programs, CACHE_TIME);
                this._onUpdate.next({ programs: this.programs });
            }
            else {
                var currentTimers = response.value.ArrayOfTimerValues;
                if (currentTimers && currentTimers.length > 0) {
                    for (var i = 0; i < currentTimers.length; i++) {
                        var timer = currentTimers[i];
                        if (timer > 0) {
                            this._zones[i].currentTime = timer;
                            this.setCache('zones', this._zones, CACHE_TIME);
                            break;
                        }
                    }
                }
            }
        }
        else if (attribute.toLowerCase() === 'mode') {
            var mode = response.value;
            var programIndex_1 = this.getProgramIdFromMode(mode);
            this._percentAdjust = this.getPercentAdjust(mode);
            this._isEnabled = this.getDeviceisEnabled(mode);
            this.state = {
                mode: mode
            };
            this._programs = this._programs.map(function (item, index) {
                item.isOn = index == programIndex_1;
                return item;
            });
            this.setCache('programs', this.programs, CACHE_TIME);
            this.setCache('percentAdjust', this.percentAdjust, CACHE_TIME);
            this.setCache('isEnabled', this.isEnabled, CACHE_TIME);
            this._onUpdate.next({
                programs: this.programs,
                state: this.state,
                isEnabled: this.isEnabled,
                percentAdjust: this.percentAdjust
            });
        }
        else if (attribute.toLowerCase() === 'arraysize') {
            this.updateArraySize(response.value);
            this.setArraySize(response.value);
        }
        return this.state;
    };
    OnOffArrayServerPlugin.prototype.getNearestCondition = function () {
        var _this = this;
        var programsIdxs = this.programs.map(function (p, idx) {
            return idx;
        });
        var query = {
            'meta.deviceId': this.device._id,
            'meta.programId': { $in: programsIdxs }
        };
        return this.conditionsService.list(query, { fields: ['meta', 'description'] })
            .map(function (response) {
            var conditions = response.data;
            var description = _this.nearestConditionDescriptionHelper(conditions);
            return description;
        });
    };
    OnOffArrayServerPlugin.prototype.getCrontabFromValue = function (value) {
        var crontabStr = value[ConditionModel.CRONTAB] || '';
        var crontab = crontabStr.split(' ');
        var date = new Date();
        var minutes = parseInt(crontab[0]);
        var hours = parseInt(crontab[1]);
        date.setUTCMinutes(minutes);
        date.setUTCHours(hours);
        var minutesUtc = date.getMinutes();
        var hoursUtc = date.getHours();
        var day = parseInt(crontab[2]);
        var monthsValues = ['*'];
        var daysStr = crontab[4] || '';
        var daysValues = daysStr.split(',').reduce(function (prev, next) {
            return next === '*' ? prev : prev.concat(next);
        }, []);
        var values = Object.assign({}, daysValues);
        daysValues = this.days.map(function (day) {
            var enabledDay = values.find(function (dayValue) {
                return parseInt(dayValue) === day.value;
            });
            day.enabled = false;
            if (enabledDay) {
                day.enabled = true;
            }
            return day;
        });
        return {
            minutes: minutesUtc,
            hours: hoursUtc,
            day: day,
            months: monthsValues,
            days: daysValues
        };
    };
    OnOffArrayServerPlugin.prototype.nearestConditionDescriptionHelper = function (conditions) {
        var _this = this;
        var currentDate = new Date();
        var currentTime = +currentDate;
        var year = currentDate.getFullYear();
        var month = currentDate.getMonth();
        var day = currentDate.getDate();
        // TODO get this from config
        var sunriseHour = 6;
        var sunsetHour = 18;
        var nearestDiff = Infinity;
        var date;
        var value;
        var description;
        conditions && conditions.forEach(function (condition) {
            if (condition.type === ConditionModel.TIME_DEFAULT) {
                value = _this.getCrontabFromValue(condition.value);
                date = new Date(year, month, day, value.hours, value.minutes);
            }
            else if (value === ConditionModel.TIME_SUNRISE) {
                date = new Date(year, month, day, sunriseHour);
            }
            else {
                date = new Date(year, month, day, sunsetHour);
            }
            var diff = +date - currentTime;
            if (diff > 0 && diff < nearestDiff) {
                nearestDiff = diff;
                description = condition.description;
            }
        });
        return description;
    };
    OnOffArrayServerPlugin.prototype.createProgramAction = function (programName, programId, startTimes, crontab, actionId, effectId) {
        var _this = this;
        var path = ['', 'devices', this.device._id, 'comps', this.componentId, 'procs', this.processorName].join('/');
        var createdAction;
        var currentTimerValues = this.programs[programId].timers || [];
        // savePrograms(currentTimerValues, programId, programName);
        var action = this.actionsService.createModel({
            name: 'Rainbee program ' + programId + ' action',
            meta: { programId: programId, deviceId: this.device._id },
            expr: { if: [], then: [], else: [], operator: 'OR' }
        });
        // this is an action update
        if (actionId) {
            action._id = actionId;
        }
        var gateway;
        var gatewayQuery = { 'components.processors.name': 'TimeServer' };
        var gatewayProjection = { fields: ['name', 'components'], limit: 1 };
        return this.devicesService.list(gatewayQuery, gatewayProjection)
            .flatMap(function (gatewaysListResponse) {
            var devices = gatewaysListResponse.data;
            gateway = devices[0];
            return action.save();
        })
            .flatMap(function (actionSaveResponse) {
            createdAction = actionSaveResponse.data;
            if (!createdAction) {
                return Observable.throw(new Error('Error saving action for raindelay'));
            }
            action._id = createdAction._id;
            var gatewayProcessor = gateway.getProcessor('TimeServer');
            var gatewayPath = [
                '',
                'devices', gateway._id,
                'comps', gatewayProcessor.componentId,
                'procs', gatewayProcessor.name,
                'attrs', 'Time'
            ].join('/');
            var conditions = [];
            for (var i = 0; i < startTimes.length; i++) {
                var time = startTimes[i];
                var value = {};
                value[ConditionModel.CRONTAB] = time.crontab ? time.crontab : crontab;
                if (time.type !== ConditionModel.TIME_DEFAULT) {
                    value[ConditionModel.EQ] =
                        time.type === ConditionModel.TIME_SUNRISE ?
                            ConditionModel.SUNRISE : ConditionModel.SUNSET;
                }
                var meta = { programId: programId, deviceId: _this.device._id };
                var condition = _this.conditionsService.createModel({
                    name: 'RainBee Program ' + programId + ' Condition',
                    path: gatewayPath,
                    value: value,
                    'parents.actions': [{ id: createdAction._id, name: createdAction.name }],
                    meta: meta,
                    type: time.type
                });
                if (time.id) {
                    condition._id = time.id;
                }
                conditions.push(condition.save());
            }
            return Observable.forkJoin(conditions);
        })
            .flatMap(function (createdConditions) {
            action.expr.if = [];
            for (var i = 0; i < createdConditions.length; i++) {
                var condition = createdConditions[i];
                condition = condition.data;
                if (condition) {
                    action.expr.if.push({
                        id: condition._id,
                        name: condition.name,
                        enabled: true
                    });
                }
            }
            var effect = _this.effectsService.createModel({
                name: 'RainBee Program ' + programId + ' Effect',
                path: path + '/methods/ProgramOn',
                'parents.actions': [{ id: createdAction._id, name: createdAction.name }],
                meta: { programId: programId, deviceId: _this.device._id },
                params: {
                    ProgramID: programId
                }
            });
            if (effectId) {
                effect._id = effectId;
            }
            return effect.save();
        })
            .flatMap(function (createdEffect) {
            createdEffect = createdEffect.data;
            if (!createdEffect) {
                Observable.throw(new Error('Error saving effect for raindelay'));
            }
            action.expr.then = [{
                    id: createdEffect._id,
                    name: createdEffect.name,
                    enabled: true
                }];
            return action.save();
        })
            .flatMap(function (updatedAction) {
            return Observable.of(updatedAction);
        });
    };
    OnOffArrayServerPlugin.prototype.getRainDelayAction = function () {
        return this.actionsService.list({ 'meta.rainDelay': true, 'meta.deviceId': this.device._id })
            .map(function (actionResult) { return actionResult.data[0]; });
    };
    OnOffArrayServerPlugin.prototype.stopRainDelay = function () {
        var _this = this;
        var promises = [];
        var actionToRemove;
        this.enableDevice();
        if (this.device && this.device.meta && this.device.meta.rainDelay) {
            var conditionId = this.device.meta.rainDelay.conditionId;
            var effectId = this.device.meta.rainDelay.effectId;
            var effectToDeleteId = this.device.meta.rainDelay.effectToDeleteId;
            var actionId = this.device.meta.rainDelay.actionId;
            if (conditionId && effectToDeleteId && effectId) {
                promises.push(this.conditionsService.createModel({ _id: conditionId }).remove());
                promises.push(this.effectsService.createModel({ _id: effectId }).remove());
                promises.push(this.effectsService.createModel({ _id: effectToDeleteId }).remove());
            }
            actionToRemove = this.actionsService.createModel({ _id: actionId });
        }
        if (!this.device.meta) {
            this.device.meta = {};
        }
        this.device.meta.rainDelay = null;
        promises.push(this.device.save());
        return Observable.forkJoin(promises).flatMap(function (arrayResponse) {
            console.log('rain delay delete response', arrayResponse);
            return actionToRemove.remove();
        }).map(function (res) {
            _this._onRainDelayChange.next(false);
            return res;
        });
    };
    OnOffArrayServerPlugin.prototype.startRainDelay = function (delay) {
        var _this = this;
        var obsResponse;
        var mode = this.state.mode;
        var path = ['', 'devices', this.device._id, 'comps', this.componentId, 'procs', this.processorName].join('/');
        var action = this.actionsService.createModel({
            name: 'RainBee Rain Delay action',
            meta: {
                rainDelay: true,
                deviceId: this.device._id,
                delay: delay
            },
            expr: { if: [], then: [], else: [], operator: 'OR' },
        });
        var time = new Date();
        if (delay !== 'inf') {
            // console.log('setting action.meta for timed');
            time.setTime(time.getTime() + (delay * 60 * 60 * 1000));
            action.meta.startDate = new Date();
            action.meta.endDate = time;
        }
        var createdAction;
        var createdCondition;
        var createdEffect;
        var createdEffectToDeleteAction;
        this.disableDevice();
        var gateway;
        var gatewayQuery = { 'components.processors.name': 'TimeServer' };
        var gatewayProjection = { fields: ['name', 'components'], limit: 1 };
        var fullResponseL = {};
        if (delay === 'inf') {
            // console.log('saving action w/o a timer effect');
            obsResponse = action.save()
                .flatMap(function (actionsResponse) {
                createdAction = action;
                if (!_this.device.meta) {
                    _this.device.meta = {};
                }
                _this.device.meta.rainDelay = {
                    delay: 'inf',
                    actionId: createdAction._id,
                };
                return _this.device.save();
            })
                .flatMap(function (deviceResponse) {
                return Observable.of(deviceResponse);
            });
        }
        else {
            obsResponse = this.devicesService.list(gatewayQuery, gatewayProjection)
                .flatMap(function (gatewayResponse) {
                gateway = gatewayResponse.data[0];
                return action.save();
            })
                .flatMap(function (actionResponse) {
                createdAction = action;
                var timeServerProcessor = gateway.getProcessor('TimeServer');
                var gatewayPath = [
                    '',
                    'devices', gateway._id,
                    'comps', timeServerProcessor.componentId,
                    'procs', timeServerProcessor.name,
                    'attrs', 'Time'
                ].join('/');
                createdCondition = _this.conditionsService.createModel({
                    name: 'Gateway triggers Rain Delay Condition',
                    'parents.actions': [{ id: createdAction._id, name: createdAction.name }],
                    meta: { rainDelay: true },
                    path: gatewayPath,
                    value: {
                        '#crontab': time.getUTCMinutes() + ' ' + time.getUTCHours() + ' * * *'
                    },
                    type: ConditionModel.TIME_DEFAULT
                });
                return createdCondition.save();
            })
                .flatMap(function (conditionResponse) {
                action.expr.if.push({
                    id: createdCondition._id,
                    name: createdCondition.name,
                    enabled: true
                });
                // Because we have inhibited the device
                // by the time the effect is running
                // the effect should be set inhibit off
                // to get the device operational again
                var newModeValue = _this.inhibitOff(mode);
                createdEffect = _this.effectsService.createModel({
                    name: 'RainBee Rain Delay Effect',
                    path: path + '/methods/setMode',
                    'parents.actions': [{ id: createdAction._id, name: createdAction.name }],
                    meta: { rainDelay: true },
                    params: { Mode: newModeValue }
                });
                return createdEffect.save();
            })
                .flatMap(function (effectResponse) {
                createdEffectToDeleteAction = _this.effectsService.createModel({
                    name: 'RainBee Effect to Delete Action',
                    path: '/actions/' + createdAction._id,
                    'parents.actions': [{ id: createdAction._id, name: createdAction.name }],
                    params: { verb: 'delete' }
                });
                return createdEffectToDeleteAction.save();
            })
                .flatMap(function (deleteEffectResponse) {
                action.expr.then.push({
                    id: createdEffect._id,
                    name: createdEffect.name,
                    enabled: true
                }, {
                    id: createdEffectToDeleteAction._id,
                    name: createdEffectToDeleteAction.name,
                    enabled: true
                });
                return action.save();
            })
                .flatMap(function (actionUpdateResponse) {
                if (!_this.device.meta) {
                    _this.device.meta = {};
                }
                _this.device.meta.rainDelay = {
                    delay: time,
                    actionId: createdAction._id,
                    conditionId: createdCondition._id,
                    effectId: createdEffect._id,
                    effectToDeleteId: createdEffectToDeleteAction._id
                };
                return _this.device.save();
            })
                .flatMap(function (deviceResponse) {
                return Observable.of(deviceResponse);
            });
        }
        return obsResponse.map(function (res) {
            _this._onRainDelayChange.next(true);
            return res;
        });
    };
    OnOffArrayServerPlugin.prototype.processDeviceMessage = function (message) {
        var attribute = message && message.attributeOrMethod;
        var response = message && message.data && message.data.response;
        if (attribute === 'OnOff') {
            var zoneId = parseInt(message.componentId);
            this._zones[zoneId - 1].isOn = response.value === 'On' || response.value === true || response.value === 1;
            this.setCache('zones', this._zones, CACHE_TIME);
            this._onUpdate.next({ zones: this.zones });
        }
    };
    OnOffArrayServerPlugin.prototype.getProgramConditions = function () {
        var programsIdxs = this.programs.map(function (p, idx) {
            return idx + '';
        });
        var query = {
            'meta.deviceId': this.device._id,
            'meta.programId': { $in: programsIdxs }
        };
        return this.conditionsService.list(query, { fields: ['meta', 'description'] });
    };
    OnOffArrayServerPlugin.prototype.setPercentAdjust = function (percent) {
        var _this = this;
        this._percentAdjust = percent;
        percent = percent / 10;
        var mode = this.state.mode;
        var percentMask = 480;
        var newMode = mode & percentMask;
        newMode |= percent;
        var params = { value: newMode };
        this.device.setAttribute(this.componentId, this.processorName, 'Mode', params).subscribe(function () {
            _this.readMode(true);
        });
    };
    OnOffArrayServerPlugin.prototype.getProgramAutomation = function (programId) {
        var observables = [];
        observables.push(this.actionsService.list({
            'meta.deviceId': this.device._id,
            'meta.programId': programId
        }, { limit: 1 }));
        observables.push(this.conditionsService.list({
            'meta.deviceId': this.device._id,
            'meta.programId': programId
        }));
        observables.push(this.effectsService.list({
            'meta.deviceId': this.device._id,
            'meta.programId': programId
        }, { limit: 1 }));
        return Observable.forkJoin(observables).flatMap(function (array) {
            var automation = [];
            for (var i = 0; i < array.length; i++) {
                var res = array[i];
                if (res && res.data) {
                    automation[i] = res.data;
                }
            }
            var response = {
                action: automation[0][0],
                conditions: automation[1],
                effect: automation[2][0]
            };
            return Observable.of(response);
        });
    };
    OnOffArrayServerPlugin.prototype.getEffectLabelOptions = function (context) {
        var _this = this;
        var rsp = [];
        var attr = '';
        if (context && context.attribute) {
            attr = context.attribute;
        }
        if (attr == 'zones') {
            rsp = this._zones.map(function (zone, index) {
                var name = zone.name;
                if (_this.device.meta && _this.device.meta.zones && _this.device.meta.zones.length >= index) {
                    name = _this.device.meta.zones[index].name;
                }
                return { name: name, value: String(index + 1), payload: { 'ZoneID': index + 1 } };
            });
        }
        else if (attr == 'programs') {
            rsp = this._programs.map(function (program, index) {
                var name = program.name;
                if (_this.device.meta && _this.device.meta.programs && _this.device.meta.programs.length >= index) {
                    name = _this.device.meta.programs[index].name;
                }
                return { name: name, value: String(index), payload: { 'ProgramID': index } };
            });
            if (rsp.length > 1) {
                rsp = rsp.slice(1);
            }
        }
        return rsp;
    };
    OnOffArrayServerPlugin.prototype.getEffectValueOptions = function (context) {
        var rsp = null;
        var attr = '';
        if (context && context.attribute) {
            attr = context.attribute;
        }
        if (attr == 'zones') {
            rsp = [
                { name: 'Turn On', value: 'On' },
                { name: 'Turn Off', value: 'Off' }
            ];
        }
        else if (attr == 'programs') {
            rsp = [
                { name: 'Turn On', value: 'ProgramOn' },
                { name: 'Turn Off', value: 'ProgramOff' }
            ];
        }
        return rsp;
    };
    OnOffArrayServerPlugin.prototype.getEffectCurrentLabel = function (context, attributeOrMethod) {
        if (!context || (!context.hasOwnProperty('ZoneID') && !context.hasOwnProperty('ProgramID')))
            return null;
        var key = context.hasOwnProperty('ZoneID') ? 'ZoneID' : 'ProgramID';
        return context[key];
    };
    OnOffArrayServerPlugin.prototype.getEffectCurrentValue = function (context, attributeOrMethod) {
        return attributeOrMethod;
    };
    OnOffArrayServerPlugin.prototype.getEffectMethod = function (context) {
        if (!context || !context['name']) {
            return null;
        }
        var name = context['name'].toLowerCase();
        var currentMethod = context['method'];
        if (name == 'zones' && ['On', 'Off'].indexOf(currentMethod) > -1) {
            return currentMethod;
        }
        else if (name == 'programs' && ['ProgramOn', 'ProgramOff'].indexOf(currentMethod) > -1) {
            return currentMethod;
        }
        return null;
    };
    return OnOffArrayServerPlugin;
}(SmartenitPlugin));
//# sourceMappingURL=on-off-array-server.plugin.js.map