var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { SmartenitPlugin } from "../smartenit-plugin";
export var OnOffPlugin = (function (_super) {
    __extends(OnOffPlugin, _super);
    function OnOffPlugin() {
        _super.apply(this, arguments);
    }
    OnOffPlugin.prototype.on = function () {
        this.state = true;
        return this.executeMethod(this.componentId, this.processorName, 'On', null);
    };
    OnOffPlugin.prototype.off = function () {
        this.state = false;
        return this.executeMethod(this.componentId, this.processorName, 'Off', null);
    };
    OnOffPlugin.prototype.toggle = function () {
        // return this.executeMethod(this.componentId, this.processorName, 'Toggle', null);
        if (this.isOn()) {
            this.off();
        }
        else {
            this.on();
        }
    };
    OnOffPlugin.prototype.isOn = function () {
        return this.state === true;
    };
    OnOffPlugin.prototype.isOff = function () {
        return this.state === false;
    };
    OnOffPlugin.prototype.getStatusPayload = function () {
        return ['OnOff'];
    };
    OnOffPlugin.prototype.getEffectOptions = function () {
        return [{
                name: 'Turn On',
                value: {
                    method: 'On'
                }
            },
            {
                name: 'Turn Off',
                value: {
                    method: 'Off'
                }
            },
            {
                name: 'Toggle',
                value: {
                    method: 'Toggle'
                }
            }];
    };
    OnOffPlugin.prototype.getResponderOptions = function () {
        return [{
                name: 'Turn On',
                value: true
            },
            {
                name: 'Turn Off',
                value: false
            }];
    };
    OnOffPlugin.prototype.getConditionOptions = function () {
        return [{
                name: 'Is On',
                value: 1
            },
            {
                name: 'Is Off',
                value: 0
            }];
    };
    OnOffPlugin.prototype.getEffectAttribute = function () {
        return 'null';
    };
    OnOffPlugin.prototype.getEffectMethod = function (context) {
        return null;
    };
    OnOffPlugin.prototype.getConditionAttribute = function () {
        return 'OnOff';
    };
    OnOffPlugin.prototype.getResponderAttribute = function () {
        return 'OnOff';
    };
    OnOffPlugin.prototype.getResponderMethod = function () {
        return null;
    };
    OnOffPlugin.prototype.processMessage = function (message) {
        var attribute = message && message.attributeOrMethod;
        if (attribute === 'state' || attribute === 'OnOff') {
            var response = message && message.data && message.data.response;
            this.state = response.value === 'On' || response.value === true || response.value === 1;
            this._onUpdate.next({ state: this.state });
        }
        return this.state;
    };
    return OnOffPlugin;
}(SmartenitPlugin));
//# sourceMappingURL=on-off.plugin.js.map