import { DatabaseService } from "../storage/database.service";
import { SmartenitPlugin } from "./smartenit-plugin";
import { DeviceModel } from "../models/device.model";
import { ActionsService } from "../resources/actions.service";
import { EffectsService } from "../resources/effects.service";
import { ConditionsService } from "../resources/conditions.service";
import { DevicesService } from "../resources/devices.service";
import { PluginUtilsService } from "./plugin-utils.service";
export declare class PluginFactoryService {
    dbService: DatabaseService;
    actionsService: ActionsService;
    effectsService: EffectsService;
    conditionsService: ConditionsService;
    pluginUtilsService: PluginUtilsService;
    private _plugins;
    constructor(dbService: DatabaseService, actionsService: ActionsService, effectsService: EffectsService, conditionsService: ConditionsService, pluginUtilsService: PluginUtilsService);
    private static getPluginKey(deviceId, componentId, processorName);
    createPlugin(pluginName: string, componentId: string, processorName: string, device: DeviceModel, devicesService: DevicesService): SmartenitPlugin;
    removePluginsForDevice(deviceId: string): void;
    clearPlugins(): void;
}
