var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { SmartenitPlugin } from '../smartenit-plugin';
import { Observable } from 'rxjs/Observable';
var BATTERY_PERCENTAGE_REMAINING_MIN = 0;
var BATTERY_PERCENTAGE_REMAINING_MAX = 255;
export var PowerConfigurationServerPlugin = (function (_super) {
    __extends(PowerConfigurationServerPlugin, _super);
    function PowerConfigurationServerPlugin() {
        _super.apply(this, arguments);
    }
    PowerConfigurationServerPlugin.prototype.onInit = function () {
        var _this = this;
        this.state.batteryPercentageRemaining = 0;
        this.getCache('battery_percentage_remaining')
            .subscribe(function (percentage) {
            if (percentage !== undefined) {
                _this.state.batteryPercentageRemaining = percentage;
            }
        });
    };
    PowerConfigurationServerPlugin.prototype.getValue = function (attribute) {
        var response = Number(this.state.batteryPercentageRemaining);
        return response;
    };
    PowerConfigurationServerPlugin.prototype.setValue = function (value, attribute, subscribe) {
        // Do nothing becase values are read only
        if (subscribe) {
            return Observable.of(true);
        }
        return true;
    };
    PowerConfigurationServerPlugin.prototype.getConditionAttribute = function () {
        return 'BatteryPercentageRemaining';
    };
    PowerConfigurationServerPlugin.prototype.getEffectAttribute = function () {
        return null;
    };
    PowerConfigurationServerPlugin.prototype.getEffectMethod = function (context) {
        return null;
    };
    PowerConfigurationServerPlugin.prototype.getUnit = function (attribute) {
        return '%';
    };
    PowerConfigurationServerPlugin.prototype.getStatus = function (context, subscribe) {
        var _this = this;
        context = 'BatteryPercentageRemaining';
        this.getCache('battery_percentage_remaining').subscribe(function (percentage) {
            if (percentage == null) {
                _this.getAttributeWithSubscribeOption(_this.componentId, _this.processorName, context, null, false);
            }
            else {
                _this.state.batteryPercentageRemaining = percentage;
                _this._onUpdate.next(percentage);
            }
        });
    };
    PowerConfigurationServerPlugin.prototype.getStatusPayload = function () {
        return ['BatteryPercentageRemaining'];
    };
    PowerConfigurationServerPlugin.prototype.processMessage = function (message) {
        var response = message && message.data && message.data.response;
        var attributeOrMethod = message && message.attributeOrMethod;
        var value = response.value;
        if (attributeOrMethod === 'BatteryPercentageRemaining') {
            var percentage = parseInt(value) / 2;
            this.setCache('battery_percentage_remaining', percentage, 3600);
            this.state.batteryPercentageRemaining = percentage;
            this._onUpdate.next(percentage);
        }
        return this.state;
    };
    PowerConfigurationServerPlugin.prototype.getRawValue = function (value, attribute, method) {
        if (!attribute || attribute === 'BatteryPercentageRemaining') {
            return this.pluginUtilsService.getValueFromPercentage(value, BATTERY_PERCENTAGE_REMAINING_MIN, BATTERY_PERCENTAGE_REMAINING_MAX);
        }
        else {
            return value;
        }
    };
    PowerConfigurationServerPlugin.prototype.getProcessedValue = function (value, attribute, method) {
        if (!attribute || attribute === 'BatteryPercentageRemaining') {
            return this.pluginUtilsService.getValueToPercentage(value, BATTERY_PERCENTAGE_REMAINING_MIN, BATTERY_PERCENTAGE_REMAINING_MAX);
        }
        else {
            return value;
        }
    };
    return PowerConfigurationServerPlugin;
}(SmartenitPlugin));
//# sourceMappingURL=power-configuration-server.plugin.js.map