var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
import { SmartenitPlugin } from '../smartenit-plugin';
import { Observable } from 'rxjs/Observable';
export var RelativeHumidityMeasurementServerPlugin = (function (_super) {
    __extends(RelativeHumidityMeasurementServerPlugin, _super);
    function RelativeHumidityMeasurementServerPlugin() {
        _super.apply(this, arguments);
    }
    Object.defineProperty(RelativeHumidityMeasurementServerPlugin.prototype, "stateTTL", {
        get: function () {
            return 2 * 60 * 1000;
        },
        enumerable: true,
        configurable: true
    });
    RelativeHumidityMeasurementServerPlugin.prototype.onInit = function () {
        var _this = this;
        this.getCache()
            .subscribe(function (state) {
            if (state !== undefined) {
                _this.state = state;
                _this._onUpdate.next({ state: state });
            }
        });
    };
    RelativeHumidityMeasurementServerPlugin.prototype.getStatus = function (context, subscribe) {
        context = 'MeasuredValue';
        this.getAttributeWithSubscribeOption(this.componentId, this.processorName, context, null, false);
    };
    RelativeHumidityMeasurementServerPlugin.prototype.setValue = function (value, attribute, subscribe) {
        // Do nothing becase values are read only
        if (subscribe) {
            return Observable.of(true);
        }
        return true;
    };
    RelativeHumidityMeasurementServerPlugin.prototype.getValue = function (attribute) {
        var response = Number(this.state);
        return response;
    };
    RelativeHumidityMeasurementServerPlugin.prototype.getConditionAttribute = function () {
        return 'MeasuredValue';
    };
    RelativeHumidityMeasurementServerPlugin.prototype.getEffectAttribute = function () {
        return null;
    };
    RelativeHumidityMeasurementServerPlugin.prototype.getEffectMethod = function (context) {
        return null;
    };
    RelativeHumidityMeasurementServerPlugin.prototype.getUnit = function (attribute) {
        return '%';
    };
    RelativeHumidityMeasurementServerPlugin.prototype.getTextValue = function (context) {
        return String(this.getValue()) + " " + this.getUnit();
    };
    RelativeHumidityMeasurementServerPlugin.prototype.getStatusPayload = function () {
        return ['MeasuredValue'];
    };
    RelativeHumidityMeasurementServerPlugin.prototype.processMessage = function (message) {
        var response = message && message.data && message.data.response || {};
        var attributeOrMethod = message && message.attributeOrMethod;
        var value = response.value;
        if (attributeOrMethod === 'MeasuredValue') {
            var measuredValue = parseInt(value) / 100;
            this.state = Math.round(measuredValue);
            this._onUpdate.next({ state: measuredValue });
        }
        return this.state;
    };
    RelativeHumidityMeasurementServerPlugin.prototype.getRawValue = function (value, attribute, method) {
        if (!attribute || attribute === 'MeasuredValue') {
            return this.pluginUtilsService.getValueByMultiplying(value, 100);
        }
        else {
            return value;
        }
    };
    RelativeHumidityMeasurementServerPlugin.prototype.getProcessedValue = function (value, attribute, method) {
        if (!attribute || attribute === 'MeasuredValue') {
            return this.pluginUtilsService.getValueByDividing(value, 100);
        }
        else {
            return value;
        }
    };
    return RelativeHumidityMeasurementServerPlugin;
}(SmartenitPlugin));
//# sourceMappingURL=relative-humidity-measurement-server.plugin.js.map