import { SmartenitPlugin } from "../smartenit-plugin";
import { IWebSocketDeviceMessage } from "../../websockets/websocket-device-message.interface";
import { ThermostatModes } from "./thermostat-modes.enum";
import { INumericValue } from "../../interfaces/numeric-value.interface";
import { ITextValue } from "../../interfaces/text-value.interface";
import { IListValue } from "../../interfaces/list-value.interface";
export declare class ThermostatServerPlugin extends SmartenitPlugin implements INumericValue, ITextValue, IListValue {
    private _mode;
    private _temperature;
    private _desiredCoolingTemperature;
    private _desiredHeatingTemperature;
    setMode(mode: ThermostatModes, subscribe?: boolean): any;
    getValue(attribute?: string): number;
    getUnit(attribute?: string): string;
    getTextValue(): string;
    getConditionAttribute(): string;
    getConditionOptions(): any;
    getEffectOptions(): any;
    getEffectAttribute(): string;
    getEffectMethod(context?: any): string;
    setValue(value: number, attribute?: string, subscribe?: boolean): any;
    getStatus(context?: string, force?: boolean, subscribe?: boolean, payload?: any): void;
    getSelectedValues(): any[];
    selectValue(option: any, subscribe?: boolean): any;
    getCachedValues(subscribe?: boolean): any;
    getStatusPayload(): any;
    processMessage(message: IWebSocketDeviceMessage): any;
    getRawValue(value: number, attribute?: string, method?: string): number;
    getProcessedValue(value: any, attribute?: string, method?: string): any;
}
