import { Observable } from "rxjs";
import { AuthService } from "../auth/auth.service";
import { EventsManagerService } from "../common/events-manager.service";
import { DataQueryService } from "../common/data-query.service";
import { DatabaseService } from "../storage/database.service";
import { PersistentCRUDService } from "../storage/persistent-crud.service";
import { SyncService } from "../storage/sync.service";
import { WebSocketsService } from "../websockets/websockets.service";
import { PluginFactoryService } from "../plugins/plugin-factory.service";
import { DeviceModel } from "../models/device.model";
import { HttpInterceptor } from "../common/http-interceptor.service";
export declare class DevicesService extends PersistentCRUDService {
    dbService: DatabaseService;
    webSocketsService: WebSocketsService;
    pluginFactory: PluginFactoryService;
    private static _devices;
    constructor(http: HttpInterceptor, authService: AuthService, dbService: DatabaseService, webSocketsService: WebSocketsService, pluginFactory: PluginFactoryService, syncService: SyncService, dataQueryService: DataQueryService, eventsService: EventsManagerService);
    discover(discoverOnlyNewDevices?: boolean): Observable<any>;
    link(deviceId: string): Observable<any>;
    linkDevice(device: any): Observable<any>;
    createModel(data: any): DeviceModel;
    removeFromLocalStorage(resourceId: string, removeData: any): Observable<any>;
    clearDevices(): void;
}
