import { Observable } from 'rxjs';
import { AuthService } from "../auth/auth.service";
import { EventsManagerService } from "../common/events-manager.service";
import { DataQueryService } from "../common/data-query.service";
import { IRequestOptions } from "../common/request-options.interface";
import { DatabaseService } from "../storage/database.service";
import { PersistentCRUDService } from "../storage/persistent-crud.service";
import { SyncService } from "../storage/sync.service";
import { EventModel } from "../models/event.model";
import { HttpInterceptor } from "../common/http-interceptor.service";
export declare class EventsService extends PersistentCRUDService {
    dbService: DatabaseService;
    constructor(http: HttpInterceptor, authService: AuthService, dbService: DatabaseService, syncService: SyncService, dataQueryService: DataQueryService, eventsManagerService: EventsManagerService);
    createModel(data: any): EventModel;
    list(query?: any, options?: IRequestOptions): Observable<any>;
}
