var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { ActionsService } from "./actions.service";
import { AreasService } from "./areas.service";
import { CategoriesService } from "./categories.service";
import { ConditionsService } from "./conditions.service";
import { ControllersService } from "./controllers.service";
import { DevicesService } from "./devices.service";
import { EffectsService } from "./effects.service";
import { EventsService } from "./events.service";
import { LocationsService } from "./locations.service";
import { PairingsService } from "./pairings.service";
import { RespondersService } from "./responders.service";
import { ScenesService } from "./scenes.service";
import { UsersService } from "./users.service";
import { WizardsService } from "./wizards.service";
import { PluginFactoryService } from '../plugins/plugin-factory.service';
import { AuthService } from '../auth/auth.service';
import { Oauth2Service } from './oauth-2.service';
import { EventsManagerService } from '../common/events-manager.service';
export var ResourcesProvider = (function () {
    function ResourcesProvider(actionsService, areasService, categoriesService, conditionsService, controllersService, devicesService, effectsService, eventsService, locationsService, pairingsService, respondersService, scenesService, usersService, wizardsService, pluginFactoryService, eventsManagerService, authService, oauth2Service) {
        var _this = this;
        this.actionsService = actionsService;
        this.areasService = areasService;
        this.categoriesService = categoriesService;
        this.conditionsService = conditionsService;
        this.controllersService = controllersService;
        this.devicesService = devicesService;
        this.effectsService = effectsService;
        this.eventsService = eventsService;
        this.locationsService = locationsService;
        this.pairingsService = pairingsService;
        this.respondersService = respondersService;
        this.scenesService = scenesService;
        this.usersService = usersService;
        this.wizardsService = wizardsService;
        this.pluginFactoryService = pluginFactoryService;
        this.eventsManagerService = eventsManagerService;
        this.resources = {
            actions: actionsService,
            areas: areasService,
            categories: categoriesService,
            conditions: conditionsService,
            controllers: controllersService,
            devices: devicesService,
            effects: effectsService,
            events: eventsService,
            locations: locationsService,
            pairings: pairingsService,
            responders: respondersService,
            scenes: scenesService,
            users: usersService,
            wizards: wizardsService
        };
        this.eventsManagerService.onUserSignIn.subscribe(function () {
            _this.tearUpResources();
        });
        this.eventsManagerService.onUserSignOut.subscribe(function () {
            _this.tearDownResources();
        });
    }
    ResourcesProvider.prototype.getResourceToken = function (resource) {
        return this.resources[resource];
    };
    ResourcesProvider.prototype.tearUpResources = function () {
        var _this = this;
        Object.keys(this.resources).forEach(function (res) {
            _this.resources[res].tearUpListAll();
        });
    };
    ResourcesProvider.prototype.tearDownResources = function () {
        var _this = this;
        Object.keys(this.resources).forEach(function (res) {
            _this.resources[res].tearDownListAll();
        });
        this.devicesService.clearDevices();
        this.pluginFactoryService.clearPlugins();
    };
    ResourcesProvider = __decorate([
        Injectable(), 
        __metadata('design:paramtypes', [ActionsService, AreasService, CategoriesService, ConditionsService, ControllersService, DevicesService, EffectsService, EventsService, LocationsService, PairingsService, RespondersService, ScenesService, UsersService, WizardsService, PluginFactoryService, EventsManagerService, AuthService, Oauth2Service])
    ], ResourcesProvider);
    return ResourcesProvider;
}());
//# sourceMappingURL=resources.provider.js.map