import { AuthService } from "../auth/auth.service";
import { EventsManagerService } from "../common/events-manager.service";
import { DataQueryService } from "../common/data-query.service";
import { Observable } from "rxjs";
import { DatabaseService } from "../storage/database.service";
import { PersistentCRUDService } from "../storage/persistent-crud.service";
import { SyncService } from "../storage/sync.service";
import { UserModel } from "../models/user.model";
import { HttpInterceptor } from "../common/http-interceptor.service";
export declare class UsersService extends PersistentCRUDService {
    dbService: DatabaseService;
    constructor(http: HttpInterceptor, authService: AuthService, dbService: DatabaseService, syncService: SyncService, dataQueryService: DataQueryService, eventsService: EventsManagerService);
    recoverPassword(username: string): Observable<any>;
    createModel(data: any): UserModel;
    createClient(userId: string, platform: string, token: string): Observable<any>;
    deleteClient(userId: string, clientId: string): Observable<any>;
}
