var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { AuthService } from "../auth/auth.service";
import { EventsManagerService } from "../common/events-manager.service";
import { DataQueryService } from "../common/data-query.service";
import { DatabaseService } from "../storage/database.service";
import { PersistentCRUDService } from "../storage/persistent-crud.service";
import { SyncService } from "../storage/sync.service";
import { UserModel } from "../models/user.model";
import { HttpInterceptor } from "../common/http-interceptor.service";
export var UsersService = (function (_super) {
    __extends(UsersService, _super);
    function UsersService(http, authService, dbService, syncService, dataQueryService, eventsService) {
        _super.call(this, 'users', http, authService, dbService, syncService, dataQueryService, eventsService);
        this.dbService = dbService;
    }
    UsersService.prototype.recoverPassword = function (username) {
        return this.post('recover_password', { username: username });
    };
    UsersService.prototype.createModel = function (data) {
        return new UserModel(this, data);
    };
    UsersService.prototype.createClient = function (userId, platform, token) {
        return this.post(userId + "/clients", { platform: platform, token: token });
    };
    UsersService.prototype.deleteClient = function (userId, clientId) {
        return this.remove(userId + "/clients/" + clientId);
    };
    UsersService = __decorate([
        Injectable(), 
        __metadata('design:paramtypes', [HttpInterceptor, AuthService, DatabaseService, SyncService, DataQueryService, EventsManagerService])
    ], UsersService);
    return UsersService;
}(PersistentCRUDService));
//# sourceMappingURL=users.service.js.map