var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import * as localforage from "localforage";
import { DatabaseCollection } from "./database-collection";
export var DatabaseService = (function () {
    function DatabaseService() {
        this._instances = {};
        localforage.config({
            name: 'smartenit',
            driver: localforage.WEBSQL,
            version: 1.1,
        });
    }
    DatabaseService.prototype.clear = function (excludedInstances) {
        var instanceKeys = Object.keys(this._instances);
        for (var i = 0; i < instanceKeys.length; i++) {
            var key = instanceKeys[i];
            if (excludedInstances && excludedInstances.length > 0 && excludedInstances.indexOf(key) < 0) {
                this._instances[key].clear();
            }
        }
    };
    DatabaseService.prototype.getCollection = function (collectionName) {
        var instance;
        if (this._instances.hasOwnProperty(collectionName)) {
            return this._instances[collectionName];
        }
        if (!instance) {
            instance = new DatabaseCollection(collectionName);
            this._instances[collectionName] = instance;
        }
        return instance;
    };
    DatabaseService = __decorate([
        Injectable(), 
        __metadata('design:paramtypes', [])
    ], DatabaseService);
    return DatabaseService;
}());
//# sourceMappingURL=database.service.js.map