import { Observable } from "rxjs";
import { AuthService } from "../auth/auth.service";
import { EventsManagerService } from "../common/events-manager.service";
import { CRUDService } from "../common/crud.service";
import { IRequestOptions } from "../common/request-options.interface";
import { DataQueryService } from "../common/data-query.service";
import { DatabaseService } from "./database.service";
import { SyncService } from "./sync.service";
import { DatabaseCollection } from "./database-collection";
import { HttpInterceptor } from "../common/http-interceptor.service";
export declare abstract class PersistentCRUDService extends CRUDService {
    private syncService;
    private dataQueryService;
    eventsService: EventsManagerService;
    protected resource: string;
    collection: DatabaseCollection;
    private listAllObservable;
    constructor(resource: string, http: HttpInterceptor, authService: AuthService, dbService: DatabaseService, syncService: SyncService, dataQueryService: DataQueryService, eventsService: EventsManagerService);
    tearUpListAll(): void;
    tearDownListAll(): void;
    save(data: any, options?: IRequestOptions): Observable<any>;
    list(query?: any, options?: IRequestOptions): Observable<any>;
    listFromLocalStorage(query?: any, options?: IRequestOptions): Observable<any>;
    listFromBackend(query?: any, options?: IRequestOptions): Observable<any>;
    listAllFromBackend(shared: boolean, query?: any, options?: IRequestOptions): Observable<any>;
    retrieveAll(page?: number, query?: any, options?: IRequestOptions, acc?: Array<any>): Observable<any>;
    processListData(resourcesList: any): Observable<any>;
    getById(resourceId: string, options?: IRequestOptions): Observable<any>;
    getByIdFromLocalStorage(resourceId: string, options?: IRequestOptions): Observable<any>;
    getByIdFromBackend(resourceId: string, options?: IRequestOptions): Observable<any>;
    remove(path?: string, data?: any, options?: IRequestOptions): Observable<any>;
    removeFromLocalStorage(resourceId: string, removeData: any): Observable<any>;
    removeById(resourceId: string, options?: IRequestOptions): Observable<any>;
    mergeInCollection(resourceId: string, resource: any): Observable<any>;
}
