var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Injectable } from '@angular/core';
import { LocalStorageService } from 'angular-2-local-storage';
export var StorageService = (function () {
    function StorageService(localStorage) {
        this.localStorage = localStorage;
    }
    StorageService.prototype.get = function (key) {
        var item = this.localStorage.get(key);
        if (item) {
            if (item.hasOwnProperty('ttl') && item.ttl !== undefined) {
                if (item.ttl >= Date.now()) {
                    return item.value;
                }
            }
            else {
                return item.value;
            }
        }
        return null;
    };
    StorageService.prototype.set = function (item) {
        var storedValue = { value: item.value };
        if (item.ttl !== undefined) {
            storedValue.ttl = Date.now() + (item.ttl * 1000);
        }
        return this.localStorage.set(item.key, storedValue);
    };
    StorageService.prototype.remove = function (item) {
        return this.localStorage.remove(item.key);
    };
    StorageService.prototype.clear = function () {
        return this.localStorage.clearAll();
    };
    StorageService = __decorate([
        Injectable(), 
        __metadata('design:paramtypes', [LocalStorageService])
    ], StorageService);
    return StorageService;
}());
//# sourceMappingURL=storage.service.js.map