import { APIClientService } from '../common/api-client.service';
import { AuthService } from "../auth/auth.service";
import { EventsManagerService } from "../common/events-manager.service";
import { Oauth2Service } from "../resources/oauth-2.service";
import { IWebSocketDeviceMessage } from "./websocket-device-message.interface";
import { Observable } from "rxjs";
import { HttpInterceptor } from "../common/http-interceptor.service";
export declare class WebSocketsService extends APIClientService {
    oauthService: Oauth2Service;
    eventsService: EventsManagerService;
    private _isConnected;
    private client;
    private reconnectionAttempts;
    private _onConnectionLost;
    private _onConnect;
    private _onConnectError;
    private _onSubscribe;
    private _onDeviceMessage;
    private _onEventsMessage;
    private _onScenesMessage;
    private _onPairingsMessage;
    private _onReady;
    private _clientDisconnect;
    readonly onConnectionLost: Observable<any>;
    readonly onConnect: Observable<any>;
    readonly onConnectError: Observable<any>;
    readonly onSubscribe: Observable<any>;
    readonly onDeviceMessage: Observable<any>;
    readonly onScenesMessage: Observable<any>;
    readonly onPairingsMessage: Observable<any>;
    readonly onEventsMessage: Observable<any>;
    readonly onReady: Observable<any>;
    constructor(http: HttpInterceptor, authService: AuthService, oauthService: Oauth2Service, eventsService: EventsManagerService);
    readonly isConnected: boolean;
    connect(): void;
    disconnect(retryable?: boolean): void;
    send(topic: string, message: any): void;
    private parseMessage(message);
    proxyMessage(message: IWebSocketDeviceMessage): void;
    private connectToMQTTBroker(hostUrl, clientId, topics);
}
